/* history.c generated by valac 0.56.14, the Vala compiler
 * generated from history.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2010-2013 Robert Ancell
   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <errno.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_HISTORY (history_get_type ())
#define HISTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY, History))
#define HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY, HistoryClass))
#define IS_HISTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY))
#define IS_HISTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY))
#define HISTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY, HistoryClass))

typedef struct _History History;
typedef struct _HistoryClass HistoryClass;
typedef struct _HistoryPrivate HistoryPrivate;

#define TYPE_HISTORY_ENTRY (history_entry_get_type ())
#define HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HISTORY_ENTRY, HistoryEntry))
#define HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HISTORY_ENTRY, HistoryEntryClass))
#define IS_HISTORY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HISTORY_ENTRY))
#define IS_HISTORY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HISTORY_ENTRY))
#define HISTORY_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HISTORY_ENTRY, HistoryEntryClass))

typedef struct _HistoryEntry HistoryEntry;
typedef struct _HistoryEntryClass HistoryEntryClass;
enum  {
	HISTORY_0_PROPERTY,
	HISTORY_FILENAME_PROPERTY,
	HISTORY_NUM_PROPERTIES
};
static GParamSpec* history_properties[HISTORY_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
enum  {
	HISTORY_ENTRY_ADDED_SIGNAL,
	HISTORY_NUM_SIGNALS
};
static guint history_signals[HISTORY_NUM_SIGNALS] = {0};
typedef struct _HistoryEntryPrivate HistoryEntryPrivate;
enum  {
	HISTORY_ENTRY_0_PROPERTY,
	HISTORY_ENTRY_DATE_PROPERTY,
	HISTORY_ENTRY_SIZE_PROPERTY,
	HISTORY_ENTRY_DURATION_PROPERTY,
	HISTORY_ENTRY_INT_DURATION_PROPERTY,
	HISTORY_ENTRY_NUM_PROPERTIES
};
static GParamSpec* history_entry_properties[HISTORY_ENTRY_NUM_PROPERTIES];

struct _History {
	GObject parent_instance;
	HistoryPrivate * priv;
	GList* entries;
};

struct _HistoryClass {
	GObjectClass parent_class;
};

struct _HistoryPrivate {
	gchar* _filename;
};

struct _HistoryEntry {
	GObject parent_instance;
	HistoryEntryPrivate * priv;
};

struct _HistoryEntryClass {
	GObjectClass parent_class;
};

struct _HistoryEntryPrivate {
	GDateTime* _date;
	guint8 _size;
	gdouble _duration;
	gboolean _int_duration;
};

static gint History_private_offset;
static gpointer history_parent_class = NULL;
static gint HistoryEntry_private_offset;
static gpointer history_entry_parent_class = NULL;

VALA_EXTERN GType history_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (History, g_object_unref)
VALA_EXTERN GType history_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (HistoryEntry, g_object_unref)
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN guint history_get_place (History* self,
                         HistoryEntry* entry,
                         guint8 puzzle_size,
                         HistoryEntry** other_entry_0,
                         HistoryEntry** other_entry_1,
                         HistoryEntry** other_entry_2);
static gint history_compare_entries (HistoryEntry* a,
                              HistoryEntry* b);
static gint _history_compare_entries_gcompare_func (gconstpointer a,
                                             gconstpointer b);
static inline void history_save (History* self);
static guint history_get_best_time_position (History* self,
                                      GList* entry_item,
                                      GList** best_time_item);
VALA_EXTERN guint8 history_entry_get_size (HistoryEntry* self);
VALA_EXTERN gboolean history_is_empty (History* self);
VALA_EXTERN void history_get_fallback_scores (History* self,
                                  guint8 puzzle_size,
                                  HistoryEntry** fallback_score_0,
                                  HistoryEntry** fallback_score_1,
                                  HistoryEntry** fallback_score_2,
                                  HistoryEntry** fallback_score_3);
VALA_EXTERN History* history_new (const gchar* filename);
VALA_EXTERN History* history_construct (GType object_type,
                            const gchar* filename);
static inline void history_load (History* self);
static const gchar* history_get_filename (History* self);
VALA_EXTERN HistoryEntry* history_entry_new (GDateTime* date,
                                 guint8 size,
                                 gdouble duration,
                                 gboolean int_duration);
VALA_EXTERN HistoryEntry* history_entry_construct (GType object_type,
                                       GDateTime* date,
                                       guint8 size,
                                       gdouble duration,
                                       gboolean int_duration);
VALA_EXTERN gboolean history_entry_get_int_duration (HistoryEntry* self);
VALA_EXTERN GDateTime* history_entry_get_date (HistoryEntry* self);
VALA_EXTERN gdouble history_entry_get_duration (HistoryEntry* self);
static void history_set_filename (History* self,
                           const gchar* value);
static void history_finalize (GObject * obj);
static GType history_get_type_once (void);
static void _vala_history_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_history_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);
VALA_EXTERN gchar* history_entry_get_duration_string (HistoryEntry* entry);
static void history_entry_set_date (HistoryEntry* self,
                             GDateTime* value);
static void history_entry_set_size (HistoryEntry* self,
                             guint8 value);
static void history_entry_set_duration (HistoryEntry* self,
                                 gdouble value);
static void history_entry_set_int_duration (HistoryEntry* self,
                                     gboolean value);
static void history_entry_finalize (GObject * obj);
static GType history_entry_get_type_once (void);
static void _vala_history_entry_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_history_entry_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
history_get_instance_private (History* self)
{
	return G_STRUCT_MEMBER_P (self, History_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 25 "../src/history.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 228 "history.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 25 "../src/history.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 236 "history.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/history.vala"
	return self ? g_object_ref (self) : NULL;
#line 244 "history.c"
}

static gint
_history_compare_entries_gcompare_func (gconstpointer a,
                                        gconstpointer b)
{
	gint result;
	result = history_compare_entries ((HistoryEntry*) a, (HistoryEntry*) b);
#line 39 "../src/history.vala"
	return result;
#line 255 "history.c"
}

guint
history_get_place (History* self,
                   HistoryEntry* entry,
                   guint8 puzzle_size,
                   HistoryEntry** other_entry_0,
                   HistoryEntry** other_entry_1,
                   HistoryEntry** other_entry_2)
{
	HistoryEntry* _vala_other_entry_0 = NULL;
	HistoryEntry* _vala_other_entry_1 = NULL;
	HistoryEntry* _vala_other_entry_2 = NULL;
	HistoryEntry* _tmp0_;
	GList* entry_item = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* best_time_item = NULL;
	guint best_position = 0U;
	GList* _tmp3_;
	GList* _tmp4_ = NULL;
	guint _tmp5_;
	guint position = 0U;
	GList* _tmp6_;
	GList* _tmp7_;
	guint result;
#line 33 "../src/history.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../src/history.vala"
	g_return_val_if_fail (entry != NULL, 0U);
#line 39 "../src/history.vala"
	_tmp0_ = _g_object_ref0 (entry);
#line 39 "../src/history.vala"
	self->entries = g_list_insert_sorted (self->entries, _tmp0_, _history_compare_entries_gcompare_func);
#line 40 "../src/history.vala"
	g_signal_emit (self, history_signals[HISTORY_ENTRY_ADDED_SIGNAL], 0, entry);
#line 41 "../src/history.vala"
	history_save (self);
#line 43 "../src/history.vala"
	_tmp1_ = self->entries;
#line 43 "../src/history.vala"
	_tmp2_ = g_list_find (_tmp1_, entry);
#line 43 "../src/history.vala"
	entry_item = _tmp2_;
#line 45 "../src/history.vala"
	_tmp3_ = entry_item;
#line 45 "../src/history.vala"
	_tmp5_ = history_get_best_time_position (self, _tmp3_, &_tmp4_);
#line 45 "../src/history.vala"
	best_time_item = _tmp4_;
#line 45 "../src/history.vala"
	best_position = _tmp5_;
#line 46 "../src/history.vala"
	_tmp6_ = self->entries;
#line 46 "../src/history.vala"
	_tmp7_ = entry_item;
#line 46 "../src/history.vala"
	position = (g_list_position (_tmp6_, _tmp7_) - best_position) + 1;
#line 47 "../src/history.vala"
	switch (position) {
#line 47 "../src/history.vala"
		case 1:
#line 318 "history.c"
		{
			GList* tmp_item = NULL;
			GList* _tmp8_;
			GList* _tmp9_;
			gboolean _tmp10_ = FALSE;
			GList* _tmp11_;
			GList* _tmp16_;
			gconstpointer _tmp17_;
			HistoryEntry* _tmp18_;
			GList* _tmp19_;
			GList* _tmp20_;
			gboolean _tmp21_ = FALSE;
			GList* _tmp22_;
			GList* _tmp27_;
			gconstpointer _tmp28_;
			HistoryEntry* _tmp29_;
			GList* _tmp30_;
			GList* _tmp31_;
			gboolean _tmp32_ = FALSE;
			GList* _tmp33_;
#line 50 "../src/history.vala"
			_tmp8_ = entry_item;
#line 50 "../src/history.vala"
			_tmp9_ = _tmp8_->next;
#line 50 "../src/history.vala"
			tmp_item = _tmp9_;
#line 51 "../src/history.vala"
			_tmp11_ = tmp_item;
#line 51 "../src/history.vala"
			if (_tmp11_ == NULL) {
#line 51 "../src/history.vala"
				_tmp10_ = TRUE;
#line 351 "history.c"
			} else {
				GList* _tmp12_;
				gconstpointer _tmp13_;
				guint8 _tmp14_;
				guint8 _tmp15_;
#line 51 "../src/history.vala"
				_tmp12_ = tmp_item;
#line 51 "../src/history.vala"
				_tmp13_ = ((GList*) _tmp12_)->data;
#line 51 "../src/history.vala"
				_tmp14_ = history_entry_get_size ((HistoryEntry*) _tmp13_);
#line 51 "../src/history.vala"
				_tmp15_ = _tmp14_;
#line 51 "../src/history.vala"
				_tmp10_ = _tmp15_ != puzzle_size;
#line 367 "history.c"
			}
#line 51 "../src/history.vala"
			if (_tmp10_) {
#line 53 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_0);
#line 53 "../src/history.vala"
				_vala_other_entry_0 = NULL;
#line 54 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_1);
#line 54 "../src/history.vala"
				_vala_other_entry_1 = NULL;
#line 55 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 55 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 56 "../src/history.vala"
				break;
#line 385 "history.c"
			}
#line 58 "../src/history.vala"
			_tmp16_ = tmp_item;
#line 58 "../src/history.vala"
			_tmp17_ = ((GList*) _tmp16_)->data;
#line 58 "../src/history.vala"
			_tmp18_ = _g_object_ref0 ((HistoryEntry*) _tmp17_);
#line 58 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_0);
#line 58 "../src/history.vala"
			_vala_other_entry_0 = _tmp18_;
#line 59 "../src/history.vala"
			_tmp19_ = tmp_item;
#line 59 "../src/history.vala"
			_tmp20_ = ((GList*) _tmp19_)->next;
#line 59 "../src/history.vala"
			tmp_item = _tmp20_;
#line 60 "../src/history.vala"
			_tmp22_ = tmp_item;
#line 60 "../src/history.vala"
			if (_tmp22_ == NULL) {
#line 60 "../src/history.vala"
				_tmp21_ = TRUE;
#line 409 "history.c"
			} else {
				GList* _tmp23_;
				gconstpointer _tmp24_;
				guint8 _tmp25_;
				guint8 _tmp26_;
#line 60 "../src/history.vala"
				_tmp23_ = tmp_item;
#line 60 "../src/history.vala"
				_tmp24_ = ((GList*) _tmp23_)->data;
#line 60 "../src/history.vala"
				_tmp25_ = history_entry_get_size ((HistoryEntry*) _tmp24_);
#line 60 "../src/history.vala"
				_tmp26_ = _tmp25_;
#line 60 "../src/history.vala"
				_tmp21_ = _tmp26_ != puzzle_size;
#line 425 "history.c"
			}
#line 60 "../src/history.vala"
			if (_tmp21_) {
#line 62 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_1);
#line 62 "../src/history.vala"
				_vala_other_entry_1 = NULL;
#line 63 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 63 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 64 "../src/history.vala"
				break;
#line 439 "history.c"
			}
#line 66 "../src/history.vala"
			_tmp27_ = tmp_item;
#line 66 "../src/history.vala"
			_tmp28_ = ((GList*) _tmp27_)->data;
#line 66 "../src/history.vala"
			_tmp29_ = _g_object_ref0 ((HistoryEntry*) _tmp28_);
#line 66 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_1);
#line 66 "../src/history.vala"
			_vala_other_entry_1 = _tmp29_;
#line 67 "../src/history.vala"
			_tmp30_ = tmp_item;
#line 67 "../src/history.vala"
			_tmp31_ = ((GList*) _tmp30_)->next;
#line 67 "../src/history.vala"
			tmp_item = _tmp31_;
#line 68 "../src/history.vala"
			_tmp33_ = tmp_item;
#line 68 "../src/history.vala"
			if (_tmp33_ == NULL) {
#line 68 "../src/history.vala"
				_tmp32_ = TRUE;
#line 463 "history.c"
			} else {
				GList* _tmp34_;
				gconstpointer _tmp35_;
				guint8 _tmp36_;
				guint8 _tmp37_;
#line 68 "../src/history.vala"
				_tmp34_ = tmp_item;
#line 68 "../src/history.vala"
				_tmp35_ = ((GList*) _tmp34_)->data;
#line 68 "../src/history.vala"
				_tmp36_ = history_entry_get_size ((HistoryEntry*) _tmp35_);
#line 68 "../src/history.vala"
				_tmp37_ = _tmp36_;
#line 68 "../src/history.vala"
				_tmp32_ = _tmp37_ != puzzle_size;
#line 479 "history.c"
			}
#line 68 "../src/history.vala"
			if (_tmp32_) {
#line 69 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 69 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 487 "history.c"
			} else {
				GList* _tmp38_;
				gconstpointer _tmp39_;
				HistoryEntry* _tmp40_;
#line 71 "../src/history.vala"
				_tmp38_ = tmp_item;
#line 71 "../src/history.vala"
				_tmp39_ = ((GList*) _tmp38_)->data;
#line 71 "../src/history.vala"
				_tmp40_ = _g_object_ref0 ((HistoryEntry*) _tmp39_);
#line 71 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 71 "../src/history.vala"
				_vala_other_entry_2 = _tmp40_;
#line 502 "history.c"
			}
#line 72 "../src/history.vala"
			break;
#line 506 "history.c"
		}
#line 47 "../src/history.vala"
		case 2:
#line 510 "history.c"
		{
			GList* _tmp41_;
			gconstpointer _tmp42_;
			HistoryEntry* _tmp43_;
			GList* tmp_item = NULL;
			GList* _tmp44_;
			GList* _tmp45_;
			gboolean _tmp46_ = FALSE;
			GList* _tmp47_;
			GList* _tmp52_;
			gconstpointer _tmp53_;
			HistoryEntry* _tmp54_;
			GList* _tmp55_;
			GList* _tmp56_;
			gboolean _tmp57_ = FALSE;
			GList* _tmp58_;
#line 75 "../src/history.vala"
			_tmp41_ = best_time_item;
#line 75 "../src/history.vala"
			_tmp42_ = _tmp41_->data;
#line 75 "../src/history.vala"
			_tmp43_ = _g_object_ref0 ((HistoryEntry*) _tmp42_);
#line 75 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_0);
#line 75 "../src/history.vala"
			_vala_other_entry_0 = _tmp43_;
#line 76 "../src/history.vala"
			_tmp44_ = entry_item;
#line 76 "../src/history.vala"
			_tmp45_ = _tmp44_->next;
#line 76 "../src/history.vala"
			tmp_item = _tmp45_;
#line 77 "../src/history.vala"
			_tmp47_ = tmp_item;
#line 77 "../src/history.vala"
			if (_tmp47_ == NULL) {
#line 77 "../src/history.vala"
				_tmp46_ = TRUE;
#line 549 "history.c"
			} else {
				GList* _tmp48_;
				gconstpointer _tmp49_;
				guint8 _tmp50_;
				guint8 _tmp51_;
#line 77 "../src/history.vala"
				_tmp48_ = tmp_item;
#line 77 "../src/history.vala"
				_tmp49_ = ((GList*) _tmp48_)->data;
#line 77 "../src/history.vala"
				_tmp50_ = history_entry_get_size ((HistoryEntry*) _tmp49_);
#line 77 "../src/history.vala"
				_tmp51_ = _tmp50_;
#line 77 "../src/history.vala"
				_tmp46_ = _tmp51_ != puzzle_size;
#line 565 "history.c"
			}
#line 77 "../src/history.vala"
			if (_tmp46_) {
#line 79 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_1);
#line 79 "../src/history.vala"
				_vala_other_entry_1 = NULL;
#line 80 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 80 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 81 "../src/history.vala"
				break;
#line 579 "history.c"
			}
#line 83 "../src/history.vala"
			_tmp52_ = tmp_item;
#line 83 "../src/history.vala"
			_tmp53_ = ((GList*) _tmp52_)->data;
#line 83 "../src/history.vala"
			_tmp54_ = _g_object_ref0 ((HistoryEntry*) _tmp53_);
#line 83 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_1);
#line 83 "../src/history.vala"
			_vala_other_entry_1 = _tmp54_;
#line 84 "../src/history.vala"
			_tmp55_ = tmp_item;
#line 84 "../src/history.vala"
			_tmp56_ = ((GList*) _tmp55_)->next;
#line 84 "../src/history.vala"
			tmp_item = _tmp56_;
#line 85 "../src/history.vala"
			_tmp58_ = tmp_item;
#line 85 "../src/history.vala"
			if (_tmp58_ == NULL) {
#line 85 "../src/history.vala"
				_tmp57_ = TRUE;
#line 603 "history.c"
			} else {
				GList* _tmp59_;
				gconstpointer _tmp60_;
				guint8 _tmp61_;
				guint8 _tmp62_;
#line 85 "../src/history.vala"
				_tmp59_ = tmp_item;
#line 85 "../src/history.vala"
				_tmp60_ = ((GList*) _tmp59_)->data;
#line 85 "../src/history.vala"
				_tmp61_ = history_entry_get_size ((HistoryEntry*) _tmp60_);
#line 85 "../src/history.vala"
				_tmp62_ = _tmp61_;
#line 85 "../src/history.vala"
				_tmp57_ = _tmp62_ != puzzle_size;
#line 619 "history.c"
			}
#line 85 "../src/history.vala"
			if (_tmp57_) {
#line 86 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 86 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 627 "history.c"
			} else {
				GList* _tmp63_;
				gconstpointer _tmp64_;
				HistoryEntry* _tmp65_;
#line 88 "../src/history.vala"
				_tmp63_ = tmp_item;
#line 88 "../src/history.vala"
				_tmp64_ = ((GList*) _tmp63_)->data;
#line 88 "../src/history.vala"
				_tmp65_ = _g_object_ref0 ((HistoryEntry*) _tmp64_);
#line 88 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 88 "../src/history.vala"
				_vala_other_entry_2 = _tmp65_;
#line 642 "history.c"
			}
#line 89 "../src/history.vala"
			break;
#line 646 "history.c"
		}
		default:
		{
			GList* _tmp66_;
			gconstpointer _tmp67_;
			HistoryEntry* _tmp68_;
			GList* _tmp69_;
			GList* _tmp70_;
			gconstpointer _tmp71_;
			HistoryEntry* _tmp72_;
			GList* next_entry_item = NULL;
			GList* _tmp73_;
			GList* _tmp74_;
			gboolean _tmp75_ = FALSE;
			GList* _tmp76_;
#line 92 "../src/history.vala"
			_tmp66_ = best_time_item;
#line 92 "../src/history.vala"
			_tmp67_ = _tmp66_->data;
#line 92 "../src/history.vala"
			_tmp68_ = _g_object_ref0 ((HistoryEntry*) _tmp67_);
#line 92 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_0);
#line 92 "../src/history.vala"
			_vala_other_entry_0 = _tmp68_;
#line 93 "../src/history.vala"
			_tmp69_ = entry_item;
#line 93 "../src/history.vala"
			_tmp70_ = _tmp69_->prev;
#line 93 "../src/history.vala"
			_tmp71_ = _tmp70_->data;
#line 93 "../src/history.vala"
			_tmp72_ = _g_object_ref0 ((HistoryEntry*) _tmp71_);
#line 93 "../src/history.vala"
			_g_object_unref0 (_vala_other_entry_1);
#line 93 "../src/history.vala"
			_vala_other_entry_1 = _tmp72_;
#line 94 "../src/history.vala"
			_tmp73_ = entry_item;
#line 94 "../src/history.vala"
			_tmp74_ = _tmp73_->next;
#line 94 "../src/history.vala"
			next_entry_item = _tmp74_;
#line 95 "../src/history.vala"
			_tmp76_ = next_entry_item;
#line 95 "../src/history.vala"
			if (_tmp76_ == NULL) {
#line 95 "../src/history.vala"
				_tmp75_ = TRUE;
#line 696 "history.c"
			} else {
				GList* _tmp77_;
				gconstpointer _tmp78_;
				guint8 _tmp79_;
				guint8 _tmp80_;
#line 95 "../src/history.vala"
				_tmp77_ = next_entry_item;
#line 95 "../src/history.vala"
				_tmp78_ = ((GList*) _tmp77_)->data;
#line 95 "../src/history.vala"
				_tmp79_ = history_entry_get_size ((HistoryEntry*) _tmp78_);
#line 95 "../src/history.vala"
				_tmp80_ = _tmp79_;
#line 95 "../src/history.vala"
				_tmp75_ = _tmp80_ != puzzle_size;
#line 712 "history.c"
			}
#line 95 "../src/history.vala"
			if (_tmp75_) {
#line 96 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 96 "../src/history.vala"
				_vala_other_entry_2 = NULL;
#line 720 "history.c"
			} else {
				GList* _tmp81_;
				gconstpointer _tmp82_;
				HistoryEntry* _tmp83_;
#line 98 "../src/history.vala"
				_tmp81_ = next_entry_item;
#line 98 "../src/history.vala"
				_tmp82_ = ((GList*) _tmp81_)->data;
#line 98 "../src/history.vala"
				_tmp83_ = _g_object_ref0 ((HistoryEntry*) _tmp82_);
#line 98 "../src/history.vala"
				_g_object_unref0 (_vala_other_entry_2);
#line 98 "../src/history.vala"
				_vala_other_entry_2 = _tmp83_;
#line 735 "history.c"
			}
#line 99 "../src/history.vala"
			break;
#line 739 "history.c"
		}
	}
#line 101 "../src/history.vala"
	result = position;
#line 101 "../src/history.vala"
	if (other_entry_0) {
#line 101 "../src/history.vala"
		*other_entry_0 = _vala_other_entry_0;
#line 748 "history.c"
	} else {
#line 101 "../src/history.vala"
		_g_object_unref0 (_vala_other_entry_0);
#line 752 "history.c"
	}
#line 101 "../src/history.vala"
	if (other_entry_1) {
#line 101 "../src/history.vala"
		*other_entry_1 = _vala_other_entry_1;
#line 758 "history.c"
	} else {
#line 101 "../src/history.vala"
		_g_object_unref0 (_vala_other_entry_1);
#line 762 "history.c"
	}
#line 101 "../src/history.vala"
	if (other_entry_2) {
#line 101 "../src/history.vala"
		*other_entry_2 = _vala_other_entry_2;
#line 768 "history.c"
	} else {
#line 101 "../src/history.vala"
		_g_object_unref0 (_vala_other_entry_2);
#line 772 "history.c"
	}
#line 101 "../src/history.vala"
	return result;
#line 776 "history.c"
}

static guint
history_get_best_time_position (History* self,
                                GList* entry_item,
                                GList** best_time_item)
{
	GList* _vala_best_time_item = NULL;
	guint8 puzzle_size = 0U;
	gconstpointer _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GList* _tmp17_;
	GList* _tmp18_;
	GList* _tmp19_;
	GList* _tmp20_;
	guint result;
#line 104 "../src/history.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 106 "../src/history.vala"
	_tmp0_ = entry_item->data;
#line 106 "../src/history.vala"
	_tmp1_ = history_entry_get_size ((HistoryEntry*) _tmp0_);
#line 106 "../src/history.vala"
	_tmp2_ = _tmp1_;
#line 106 "../src/history.vala"
	puzzle_size = _tmp2_;
#line 107 "../src/history.vala"
	_tmp3_ = self->entries;
#line 107 "../src/history.vala"
	_tmp4_ = g_list_first (_tmp3_);
#line 107 "../src/history.vala"
	_vala_best_time_item = _tmp4_;
#line 108 "../src/history.vala"
	if (((gint) puzzle_size) == 2) {
#line 108 "../src/history.vala"
		_tmp5_ = TRUE;
#line 817 "history.c"
	} else {
		GList* _tmp6_;
#line 108 "../src/history.vala"
		_tmp6_ = _vala_best_time_item;
#line 108 "../src/history.vala"
		_tmp5_ = entry_item == _tmp6_;
#line 824 "history.c"
	}
#line 108 "../src/history.vala"
	if (_tmp5_) {
#line 109 "../src/history.vala"
		result = (guint) 0;
#line 109 "../src/history.vala"
		if (best_time_item) {
#line 109 "../src/history.vala"
			*best_time_item = _vala_best_time_item;
#line 834 "history.c"
		}
#line 109 "../src/history.vala"
		return result;
#line 838 "history.c"
	}
#line 111 "../src/history.vala"
	_vala_best_time_item = entry_item;
#line 842 "history.c"
	{
		gboolean _tmp7_ = FALSE;
#line 112 "../src/history.vala"
		_tmp7_ = TRUE;
#line 112 "../src/history.vala"
		while (TRUE) {
#line 849 "history.c"
			GList* _tmp15_;
			GList* _tmp16_;
#line 112 "../src/history.vala"
			if (!_tmp7_) {
#line 854 "history.c"
				gboolean _tmp8_ = FALSE;
				GList* _tmp9_;
				GList* _tmp10_;
#line 113 "../src/history.vala"
				_tmp9_ = _vala_best_time_item;
#line 113 "../src/history.vala"
				_tmp10_ = self->entries;
#line 113 "../src/history.vala"
				if (_tmp9_ != _tmp10_) {
#line 864 "history.c"
					GList* _tmp11_;
					gconstpointer _tmp12_;
					guint8 _tmp13_;
					guint8 _tmp14_;
#line 113 "../src/history.vala"
					_tmp11_ = _vala_best_time_item;
#line 113 "../src/history.vala"
					_tmp12_ = _tmp11_->data;
#line 113 "../src/history.vala"
					_tmp13_ = history_entry_get_size ((HistoryEntry*) _tmp12_);
#line 113 "../src/history.vala"
					_tmp14_ = _tmp13_;
#line 113 "../src/history.vala"
					_tmp8_ = _tmp14_ == puzzle_size;
#line 879 "history.c"
				} else {
#line 113 "../src/history.vala"
					_tmp8_ = FALSE;
#line 883 "history.c"
				}
#line 113 "../src/history.vala"
				if (!_tmp8_) {
#line 113 "../src/history.vala"
					break;
#line 889 "history.c"
				}
			}
#line 112 "../src/history.vala"
			_tmp7_ = FALSE;
#line 112 "../src/history.vala"
			_tmp15_ = _vala_best_time_item;
#line 112 "../src/history.vala"
			_tmp16_ = _tmp15_->prev;
#line 112 "../src/history.vala"
			_vala_best_time_item = _tmp16_;
#line 900 "history.c"
		}
	}
#line 114 "../src/history.vala"
	_tmp17_ = _vala_best_time_item;
#line 114 "../src/history.vala"
	_tmp18_ = _tmp17_->next;
#line 114 "../src/history.vala"
	_vala_best_time_item = _tmp18_;
#line 115 "../src/history.vala"
	_tmp19_ = self->entries;
#line 115 "../src/history.vala"
	_tmp20_ = _vala_best_time_item;
#line 115 "../src/history.vala"
	result = (guint) g_list_position (_tmp19_, _tmp20_);
#line 115 "../src/history.vala"
	if (best_time_item) {
#line 115 "../src/history.vala"
		*best_time_item = _vala_best_time_item;
#line 919 "history.c"
	}
#line 115 "../src/history.vala"
	return result;
#line 923 "history.c"
}

gboolean
history_is_empty (History* self)
{
	GList* first_entry = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 118 "../src/history.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 120 "../src/history.vala"
	_tmp0_ = self->entries;
#line 120 "../src/history.vala"
	_tmp1_ = g_list_first (_tmp0_);
#line 120 "../src/history.vala"
	first_entry = _tmp1_;
#line 121 "../src/history.vala"
	result = first_entry == NULL;
#line 121 "../src/history.vala"
	return result;
#line 945 "history.c"
}

void
history_get_fallback_scores (History* self,
                             guint8 puzzle_size,
                             HistoryEntry** fallback_score_0,
                             HistoryEntry** fallback_score_1,
                             HistoryEntry** fallback_score_2,
                             HistoryEntry** fallback_score_3)
{
	HistoryEntry* _vala_fallback_score_0 = NULL;
	HistoryEntry* _vala_fallback_score_1 = NULL;
	HistoryEntry* _vala_fallback_score_2 = NULL;
	HistoryEntry* _vala_fallback_score_3 = NULL;
	GList* tmp_item = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gboolean _tmp10_ = FALSE;
	GList* _tmp11_;
	GList* _tmp16_;
	gconstpointer _tmp17_;
	HistoryEntry* _tmp18_;
	GList* _tmp19_;
	GList* _tmp20_;
	gboolean _tmp21_ = FALSE;
	GList* _tmp22_;
	GList* _tmp27_;
	gconstpointer _tmp28_;
	HistoryEntry* _tmp29_;
	GList* _tmp30_;
	GList* _tmp31_;
	gboolean _tmp32_ = FALSE;
	GList* _tmp33_;
	GList* _tmp38_;
	gconstpointer _tmp39_;
	HistoryEntry* _tmp40_;
	GList* _tmp41_;
	GList* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GList* _tmp44_;
	GList* tmp_item_prev = NULL;
	GList* _tmp49_;
	GList* _tmp60_;
	gconstpointer _tmp61_;
	HistoryEntry* _tmp62_;
#line 124 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/history.vala"
	_tmp0_ = self->entries;
#line 130 "../src/history.vala"
	_tmp1_ = g_list_first (_tmp0_);
#line 130 "../src/history.vala"
	tmp_item = _tmp1_;
#line 132 "../src/history.vala"
	while (TRUE) {
#line 1001 "history.c"
		gboolean _tmp2_ = FALSE;
		GList* _tmp3_;
		GList* _tmp8_;
		GList* _tmp9_;
#line 132 "../src/history.vala"
		_tmp3_ = tmp_item;
#line 132 "../src/history.vala"
		if (_tmp3_ != NULL) {
#line 1010 "history.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
			guint8 _tmp6_;
			guint8 _tmp7_;
#line 132 "../src/history.vala"
			_tmp4_ = tmp_item;
#line 132 "../src/history.vala"
			_tmp5_ = ((GList*) _tmp4_)->data;
#line 132 "../src/history.vala"
			_tmp6_ = history_entry_get_size ((HistoryEntry*) _tmp5_);
#line 132 "../src/history.vala"
			_tmp7_ = _tmp6_;
#line 132 "../src/history.vala"
			_tmp2_ = _tmp7_ < puzzle_size;
#line 1025 "history.c"
		} else {
#line 132 "../src/history.vala"
			_tmp2_ = FALSE;
#line 1029 "history.c"
		}
#line 132 "../src/history.vala"
		if (!_tmp2_) {
#line 132 "../src/history.vala"
			break;
#line 1035 "history.c"
		}
#line 133 "../src/history.vala"
		_tmp8_ = tmp_item;
#line 133 "../src/history.vala"
		_tmp9_ = ((GList*) _tmp8_)->next;
#line 133 "../src/history.vala"
		tmp_item = _tmp9_;
#line 1043 "history.c"
	}
#line 135 "../src/history.vala"
	_tmp11_ = tmp_item;
#line 135 "../src/history.vala"
	if (_tmp11_ == NULL) {
#line 135 "../src/history.vala"
		_tmp10_ = TRUE;
#line 1051 "history.c"
	} else {
		GList* _tmp12_;
		gconstpointer _tmp13_;
		guint8 _tmp14_;
		guint8 _tmp15_;
#line 135 "../src/history.vala"
		_tmp12_ = tmp_item;
#line 135 "../src/history.vala"
		_tmp13_ = ((GList*) _tmp12_)->data;
#line 135 "../src/history.vala"
		_tmp14_ = history_entry_get_size ((HistoryEntry*) _tmp13_);
#line 135 "../src/history.vala"
		_tmp15_ = _tmp14_;
#line 135 "../src/history.vala"
		_tmp10_ = _tmp15_ != puzzle_size;
#line 1067 "history.c"
	}
#line 135 "../src/history.vala"
	if (_tmp10_) {
#line 137 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_0);
#line 137 "../src/history.vala"
		_vala_fallback_score_0 = NULL;
#line 138 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_1);
#line 138 "../src/history.vala"
		_vala_fallback_score_1 = NULL;
#line 139 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_2);
#line 139 "../src/history.vala"
		_vala_fallback_score_2 = NULL;
#line 140 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_3);
#line 140 "../src/history.vala"
		_vala_fallback_score_3 = NULL;
#line 141 "../src/history.vala"
		if (fallback_score_0) {
#line 141 "../src/history.vala"
			*fallback_score_0 = _vala_fallback_score_0;
#line 1091 "history.c"
		} else {
#line 141 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_0);
#line 1095 "history.c"
		}
#line 141 "../src/history.vala"
		if (fallback_score_1) {
#line 141 "../src/history.vala"
			*fallback_score_1 = _vala_fallback_score_1;
#line 1101 "history.c"
		} else {
#line 141 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_1);
#line 1105 "history.c"
		}
#line 141 "../src/history.vala"
		if (fallback_score_2) {
#line 141 "../src/history.vala"
			*fallback_score_2 = _vala_fallback_score_2;
#line 1111 "history.c"
		} else {
#line 141 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_2);
#line 1115 "history.c"
		}
#line 141 "../src/history.vala"
		if (fallback_score_3) {
#line 141 "../src/history.vala"
			*fallback_score_3 = _vala_fallback_score_3;
#line 1121 "history.c"
		} else {
#line 141 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_3);
#line 1125 "history.c"
		}
#line 141 "../src/history.vala"
		return;
#line 1129 "history.c"
	}
#line 143 "../src/history.vala"
	_tmp16_ = tmp_item;
#line 143 "../src/history.vala"
	_tmp17_ = ((GList*) _tmp16_)->data;
#line 143 "../src/history.vala"
	_tmp18_ = _g_object_ref0 ((HistoryEntry*) _tmp17_);
#line 143 "../src/history.vala"
	_g_object_unref0 (_vala_fallback_score_0);
#line 143 "../src/history.vala"
	_vala_fallback_score_0 = _tmp18_;
#line 145 "../src/history.vala"
	_tmp19_ = tmp_item;
#line 145 "../src/history.vala"
	_tmp20_ = ((GList*) _tmp19_)->next;
#line 145 "../src/history.vala"
	tmp_item = _tmp20_;
#line 146 "../src/history.vala"
	_tmp22_ = tmp_item;
#line 146 "../src/history.vala"
	if (_tmp22_ == NULL) {
#line 146 "../src/history.vala"
		_tmp21_ = TRUE;
#line 1153 "history.c"
	} else {
		GList* _tmp23_;
		gconstpointer _tmp24_;
		guint8 _tmp25_;
		guint8 _tmp26_;
#line 146 "../src/history.vala"
		_tmp23_ = tmp_item;
#line 146 "../src/history.vala"
		_tmp24_ = ((GList*) _tmp23_)->data;
#line 146 "../src/history.vala"
		_tmp25_ = history_entry_get_size ((HistoryEntry*) _tmp24_);
#line 146 "../src/history.vala"
		_tmp26_ = _tmp25_;
#line 146 "../src/history.vala"
		_tmp21_ = _tmp26_ != puzzle_size;
#line 1169 "history.c"
	}
#line 146 "../src/history.vala"
	if (_tmp21_) {
#line 148 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_1);
#line 148 "../src/history.vala"
		_vala_fallback_score_1 = NULL;
#line 149 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_2);
#line 149 "../src/history.vala"
		_vala_fallback_score_2 = NULL;
#line 150 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_3);
#line 150 "../src/history.vala"
		_vala_fallback_score_3 = NULL;
#line 151 "../src/history.vala"
		if (fallback_score_0) {
#line 151 "../src/history.vala"
			*fallback_score_0 = _vala_fallback_score_0;
#line 1189 "history.c"
		} else {
#line 151 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_0);
#line 1193 "history.c"
		}
#line 151 "../src/history.vala"
		if (fallback_score_1) {
#line 151 "../src/history.vala"
			*fallback_score_1 = _vala_fallback_score_1;
#line 1199 "history.c"
		} else {
#line 151 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_1);
#line 1203 "history.c"
		}
#line 151 "../src/history.vala"
		if (fallback_score_2) {
#line 151 "../src/history.vala"
			*fallback_score_2 = _vala_fallback_score_2;
#line 1209 "history.c"
		} else {
#line 151 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_2);
#line 1213 "history.c"
		}
#line 151 "../src/history.vala"
		if (fallback_score_3) {
#line 151 "../src/history.vala"
			*fallback_score_3 = _vala_fallback_score_3;
#line 1219 "history.c"
		} else {
#line 151 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_3);
#line 1223 "history.c"
		}
#line 151 "../src/history.vala"
		return;
#line 1227 "history.c"
	}
#line 153 "../src/history.vala"
	_tmp27_ = tmp_item;
#line 153 "../src/history.vala"
	_tmp28_ = ((GList*) _tmp27_)->data;
#line 153 "../src/history.vala"
	_tmp29_ = _g_object_ref0 ((HistoryEntry*) _tmp28_);
#line 153 "../src/history.vala"
	_g_object_unref0 (_vala_fallback_score_1);
#line 153 "../src/history.vala"
	_vala_fallback_score_1 = _tmp29_;
#line 155 "../src/history.vala"
	_tmp30_ = tmp_item;
#line 155 "../src/history.vala"
	_tmp31_ = ((GList*) _tmp30_)->next;
#line 155 "../src/history.vala"
	tmp_item = _tmp31_;
#line 156 "../src/history.vala"
	_tmp33_ = tmp_item;
#line 156 "../src/history.vala"
	if (_tmp33_ == NULL) {
#line 156 "../src/history.vala"
		_tmp32_ = TRUE;
#line 1251 "history.c"
	} else {
		GList* _tmp34_;
		gconstpointer _tmp35_;
		guint8 _tmp36_;
		guint8 _tmp37_;
#line 156 "../src/history.vala"
		_tmp34_ = tmp_item;
#line 156 "../src/history.vala"
		_tmp35_ = ((GList*) _tmp34_)->data;
#line 156 "../src/history.vala"
		_tmp36_ = history_entry_get_size ((HistoryEntry*) _tmp35_);
#line 156 "../src/history.vala"
		_tmp37_ = _tmp36_;
#line 156 "../src/history.vala"
		_tmp32_ = _tmp37_ != puzzle_size;
#line 1267 "history.c"
	}
#line 156 "../src/history.vala"
	if (_tmp32_) {
#line 158 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_2);
#line 158 "../src/history.vala"
		_vala_fallback_score_2 = NULL;
#line 159 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_3);
#line 159 "../src/history.vala"
		_vala_fallback_score_3 = NULL;
#line 160 "../src/history.vala"
		if (fallback_score_0) {
#line 160 "../src/history.vala"
			*fallback_score_0 = _vala_fallback_score_0;
#line 1283 "history.c"
		} else {
#line 160 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_0);
#line 1287 "history.c"
		}
#line 160 "../src/history.vala"
		if (fallback_score_1) {
#line 160 "../src/history.vala"
			*fallback_score_1 = _vala_fallback_score_1;
#line 1293 "history.c"
		} else {
#line 160 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_1);
#line 1297 "history.c"
		}
#line 160 "../src/history.vala"
		if (fallback_score_2) {
#line 160 "../src/history.vala"
			*fallback_score_2 = _vala_fallback_score_2;
#line 1303 "history.c"
		} else {
#line 160 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_2);
#line 1307 "history.c"
		}
#line 160 "../src/history.vala"
		if (fallback_score_3) {
#line 160 "../src/history.vala"
			*fallback_score_3 = _vala_fallback_score_3;
#line 1313 "history.c"
		} else {
#line 160 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_3);
#line 1317 "history.c"
		}
#line 160 "../src/history.vala"
		return;
#line 1321 "history.c"
	}
#line 162 "../src/history.vala"
	_tmp38_ = tmp_item;
#line 162 "../src/history.vala"
	_tmp39_ = ((GList*) _tmp38_)->data;
#line 162 "../src/history.vala"
	_tmp40_ = _g_object_ref0 ((HistoryEntry*) _tmp39_);
#line 162 "../src/history.vala"
	_g_object_unref0 (_vala_fallback_score_2);
#line 162 "../src/history.vala"
	_vala_fallback_score_2 = _tmp40_;
#line 164 "../src/history.vala"
	_tmp41_ = tmp_item;
#line 164 "../src/history.vala"
	_tmp42_ = ((GList*) _tmp41_)->next;
#line 164 "../src/history.vala"
	tmp_item = _tmp42_;
#line 165 "../src/history.vala"
	_tmp44_ = tmp_item;
#line 165 "../src/history.vala"
	if (_tmp44_ == NULL) {
#line 165 "../src/history.vala"
		_tmp43_ = TRUE;
#line 1345 "history.c"
	} else {
		GList* _tmp45_;
		gconstpointer _tmp46_;
		guint8 _tmp47_;
		guint8 _tmp48_;
#line 165 "../src/history.vala"
		_tmp45_ = tmp_item;
#line 165 "../src/history.vala"
		_tmp46_ = ((GList*) _tmp45_)->data;
#line 165 "../src/history.vala"
		_tmp47_ = history_entry_get_size ((HistoryEntry*) _tmp46_);
#line 165 "../src/history.vala"
		_tmp48_ = _tmp47_;
#line 165 "../src/history.vala"
		_tmp43_ = _tmp48_ != puzzle_size;
#line 1361 "history.c"
	}
#line 165 "../src/history.vala"
	if (_tmp43_) {
#line 167 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_3);
#line 167 "../src/history.vala"
		_vala_fallback_score_3 = NULL;
#line 168 "../src/history.vala"
		if (fallback_score_0) {
#line 168 "../src/history.vala"
			*fallback_score_0 = _vala_fallback_score_0;
#line 1373 "history.c"
		} else {
#line 168 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_0);
#line 1377 "history.c"
		}
#line 168 "../src/history.vala"
		if (fallback_score_1) {
#line 168 "../src/history.vala"
			*fallback_score_1 = _vala_fallback_score_1;
#line 1383 "history.c"
		} else {
#line 168 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_1);
#line 1387 "history.c"
		}
#line 168 "../src/history.vala"
		if (fallback_score_2) {
#line 168 "../src/history.vala"
			*fallback_score_2 = _vala_fallback_score_2;
#line 1393 "history.c"
		} else {
#line 168 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_2);
#line 1397 "history.c"
		}
#line 168 "../src/history.vala"
		if (fallback_score_3) {
#line 168 "../src/history.vala"
			*fallback_score_3 = _vala_fallback_score_3;
#line 1403 "history.c"
		} else {
#line 168 "../src/history.vala"
			_g_object_unref0 (_vala_fallback_score_3);
#line 1407 "history.c"
		}
#line 168 "../src/history.vala"
		return;
#line 1411 "history.c"
	}
#line 171 "../src/history.vala"
	_tmp49_ = tmp_item;
#line 171 "../src/history.vala"
	tmp_item_prev = (GList*) _tmp49_;
#line 1417 "history.c"
	{
		gboolean _tmp50_ = FALSE;
#line 172 "../src/history.vala"
		_tmp50_ = TRUE;
#line 172 "../src/history.vala"
		while (TRUE) {
#line 1424 "history.c"
			GList* _tmp57_;
			GList* _tmp58_;
			GList* _tmp59_;
#line 172 "../src/history.vala"
			if (!_tmp50_) {
#line 1430 "history.c"
				gboolean _tmp51_ = FALSE;
				GList* _tmp52_;
#line 173 "../src/history.vala"
				_tmp52_ = tmp_item;
#line 173 "../src/history.vala"
				if (_tmp52_ != NULL) {
#line 1437 "history.c"
					GList* _tmp53_;
					gconstpointer _tmp54_;
					guint8 _tmp55_;
					guint8 _tmp56_;
#line 173 "../src/history.vala"
					_tmp53_ = tmp_item;
#line 173 "../src/history.vala"
					_tmp54_ = ((GList*) _tmp53_)->data;
#line 173 "../src/history.vala"
					_tmp55_ = history_entry_get_size ((HistoryEntry*) _tmp54_);
#line 173 "../src/history.vala"
					_tmp56_ = _tmp55_;
#line 173 "../src/history.vala"
					_tmp51_ = _tmp56_ == puzzle_size;
#line 1452 "history.c"
				} else {
#line 173 "../src/history.vala"
					_tmp51_ = FALSE;
#line 1456 "history.c"
				}
#line 173 "../src/history.vala"
				if (!_tmp51_) {
#line 173 "../src/history.vala"
					break;
#line 1462 "history.c"
				}
			}
#line 172 "../src/history.vala"
			_tmp50_ = FALSE;
#line 172 "../src/history.vala"
			_tmp57_ = tmp_item;
#line 172 "../src/history.vala"
			tmp_item_prev = (GList*) _tmp57_;
#line 172 "../src/history.vala"
			_tmp58_ = tmp_item;
#line 172 "../src/history.vala"
			_tmp59_ = ((GList*) _tmp58_)->next;
#line 172 "../src/history.vala"
			tmp_item = _tmp59_;
#line 1477 "history.c"
		}
	}
#line 174 "../src/history.vala"
	_tmp60_ = tmp_item_prev;
#line 174 "../src/history.vala"
	_tmp61_ = _tmp60_->data;
#line 174 "../src/history.vala"
	_tmp62_ = _g_object_ref0 ((HistoryEntry*) _tmp61_);
#line 174 "../src/history.vala"
	_g_object_unref0 (_vala_fallback_score_3);
#line 174 "../src/history.vala"
	_vala_fallback_score_3 = _tmp62_;
#line 124 "../src/history.vala"
	if (fallback_score_0) {
#line 124 "../src/history.vala"
		*fallback_score_0 = _vala_fallback_score_0;
#line 1494 "history.c"
	} else {
#line 124 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_0);
#line 1498 "history.c"
	}
#line 124 "../src/history.vala"
	if (fallback_score_1) {
#line 124 "../src/history.vala"
		*fallback_score_1 = _vala_fallback_score_1;
#line 1504 "history.c"
	} else {
#line 124 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_1);
#line 1508 "history.c"
	}
#line 124 "../src/history.vala"
	if (fallback_score_2) {
#line 124 "../src/history.vala"
		*fallback_score_2 = _vala_fallback_score_2;
#line 1514 "history.c"
	} else {
#line 124 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_2);
#line 1518 "history.c"
	}
#line 124 "../src/history.vala"
	if (fallback_score_3) {
#line 124 "../src/history.vala"
		*fallback_score_3 = _vala_fallback_score_3;
#line 1524 "history.c"
	} else {
#line 124 "../src/history.vala"
		_g_object_unref0 (_vala_fallback_score_3);
#line 1528 "history.c"
	}
}

History*
history_construct (GType object_type,
                   const gchar* filename)
{
	History * self = NULL;
#line 181 "../src/history.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 183 "../src/history.vala"
	self = (History*) g_object_new (object_type, "filename", filename, NULL);
#line 184 "../src/history.vala"
	history_load (self);
#line 181 "../src/history.vala"
	return self;
#line 1545 "history.c"
}

History*
history_new (const gchar* filename)
{
#line 181 "../src/history.vala"
	return history_construct (TYPE_HISTORY, filename);
#line 1553 "history.c"
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1589 "history.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 1597 "history.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 1601 "history.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1609 "history.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1615 "history.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 1619 "history.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1632 "history.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1638 "history.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 1642 "history.c"
	}
}

static gboolean
double_try_parse (const gchar* str,
                  gdouble* _result_,
                  const gchar** unparsed)
{
	gdouble _vala__result_ = 0.0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gdouble _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 1007 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 1009 "glib-2.0.vapi"
	errno = 0;
#line 1010 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtod (str, &_tmp0_);
#line 1010 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 1010 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 1011 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 1011 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 1011 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1011 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 1012 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 1013 "glib-2.0.vapi"
		result = errno != ERANGE;
#line 1013 "glib-2.0.vapi"
		if (_result_) {
#line 1013 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1686 "history.c"
		}
#line 1013 "glib-2.0.vapi"
		if (unparsed) {
#line 1013 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1692 "history.c"
		}
#line 1013 "glib-2.0.vapi"
		return result;
#line 1696 "history.c"
	} else {
		gchar* _tmp5_;
#line 1015 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 1015 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 1016 "glib-2.0.vapi"
		result = FALSE;
#line 1016 "glib-2.0.vapi"
		if (_result_) {
#line 1016 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 1709 "history.c"
		}
#line 1016 "glib-2.0.vapi"
		if (unparsed) {
#line 1016 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 1715 "history.c"
		}
#line 1016 "glib-2.0.vapi"
		return result;
#line 1719 "history.c"
	}
}

static inline void
history_load (History* self)
{
	gchar* contents = NULL;
	gchar* _tmp0_;
	const gchar* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	GError* _inner_error0_ = NULL;
#line 187 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/history.vala"
	_tmp0_ = g_strdup ("");
#line 189 "../src/history.vala"
	contents = _tmp0_;
#line 1738 "history.c"
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
#line 192 "../src/history.vala"
		_tmp1_ = self->priv->_filename;
#line 192 "../src/history.vala"
		g_file_get_contents (_tmp1_, &_tmp2_, NULL, &_inner_error0_);
#line 192 "../src/history.vala"
		_g_free0 (contents);
#line 192 "../src/history.vala"
		contents = _tmp2_;
#line 192 "../src/history.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 192 "../src/history.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1754 "history.c"
				goto __catch0_g_file_error;
			}
#line 192 "../src/history.vala"
			_g_free0 (contents);
#line 192 "../src/history.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 192 "../src/history.vala"
			g_clear_error (&_inner_error0_);
#line 192 "../src/history.vala"
			return;
#line 1765 "history.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
#line 190 "../src/history.vala"
		e = _inner_error0_;
#line 190 "../src/history.vala"
		_inner_error0_ = NULL;
#line 196 "../src/history.vala"
		_tmp3_ = e;
#line 196 "../src/history.vala"
		if (!g_error_matches (_tmp3_, G_FILE_ERROR, G_FILE_ERROR_NOENT)) {
#line 1781 "history.c"
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 197 "../src/history.vala"
			_tmp4_ = e;
#line 197 "../src/history.vala"
			_tmp5_ = _tmp4_->message;
#line 197 "../src/history.vala"
			g_warning ("history.vala:197: Failed to load history: %s", _tmp5_);
#line 1790 "history.c"
		}
#line 198 "../src/history.vala"
		_g_error_free0 (e);
#line 198 "../src/history.vala"
		_g_free0 (contents);
#line 198 "../src/history.vala"
		return;
#line 1798 "history.c"
	}
	__finally0:
#line 190 "../src/history.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/history.vala"
		_g_free0 (contents);
#line 190 "../src/history.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/history.vala"
		g_clear_error (&_inner_error0_);
#line 190 "../src/history.vala"
		return;
#line 1811 "history.c"
	}
#line 201 "../src/history.vala"
	_tmp6_ = contents;
#line 201 "../src/history.vala"
	_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "\n", 0);
#line 1817 "history.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 201 "../src/history.vala"
		line_collection = _tmp8_;
#line 201 "../src/history.vala"
		line_collection_length1 = _vala_array_length (_tmp7_);
#line 201 "../src/history.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1829 "history.c"
			gchar* _tmp9_;
			gchar* line = NULL;
#line 201 "../src/history.vala"
			_tmp9_ = g_strdup (line_collection[line_it]);
#line 201 "../src/history.vala"
			line = _tmp9_;
#line 1836 "history.c"
			{
				gchar** tokens = NULL;
				const gchar* _tmp10_;
				gchar** _tmp11_;
				gchar** _tmp12_;
				gint tokens_length1;
				gint _tokens_size_;
				gchar** _tmp13_;
				gint _tmp13__length1;
				GDateTime* date = NULL;
				gchar** _tmp14_;
				gint _tmp14__length1;
				const gchar* _tmp15_;
				GDateTime* _tmp16_;
				GDateTime* _tmp17_;
				guint64 test = 0ULL;
				gchar** _tmp18_;
				gint _tmp18__length1;
				const gchar* _tmp19_;
				guint64 _tmp20_ = 0ULL;
				gboolean _tmp21_;
				gboolean _tmp22_ = FALSE;
				guint8 size = 0U;
				gdouble duration = 0.0;
				gboolean int_duration = FALSE;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				guint64 _tmp25_ = 0ULL;
				gboolean _tmp26_;
				GDateTime* _tmp31_;
				HistoryEntry* _tmp32_;
#line 203 "../src/history.vala"
				_tmp10_ = line;
#line 203 "../src/history.vala"
				_tmp12_ = _tmp11_ = g_strsplit (_tmp10_, " ", 0);
#line 203 "../src/history.vala"
				tokens = _tmp12_;
#line 203 "../src/history.vala"
				tokens_length1 = _vala_array_length (_tmp11_);
#line 203 "../src/history.vala"
				_tokens_size_ = tokens_length1;
#line 204 "../src/history.vala"
				_tmp13_ = tokens;
#line 204 "../src/history.vala"
				_tmp13__length1 = tokens_length1;
#line 204 "../src/history.vala"
				if (_tmp13__length1 != 3) {
#line 205 "../src/history.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 205 "../src/history.vala"
					_g_free0 (line);
#line 205 "../src/history.vala"
					continue;
#line 1891 "history.c"
				}
#line 207 "../src/history.vala"
				_tmp14_ = tokens;
#line 207 "../src/history.vala"
				_tmp14__length1 = tokens_length1;
#line 207 "../src/history.vala"
				_tmp15_ = _tmp14_[0];
#line 207 "../src/history.vala"
				_tmp16_ = g_date_time_new_from_iso8601 (_tmp15_, NULL);
#line 207 "../src/history.vala"
				date = _tmp16_;
#line 208 "../src/history.vala"
				_tmp17_ = date;
#line 208 "../src/history.vala"
				if (_tmp17_ == NULL) {
#line 209 "../src/history.vala"
					_g_date_time_unref0 (date);
#line 209 "../src/history.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 209 "../src/history.vala"
					_g_free0 (line);
#line 209 "../src/history.vala"
					continue;
#line 1915 "history.c"
				}
#line 212 "../src/history.vala"
				_tmp18_ = tokens;
#line 212 "../src/history.vala"
				_tmp18__length1 = tokens_length1;
#line 212 "../src/history.vala"
				_tmp19_ = _tmp18_[1];
#line 212 "../src/history.vala"
				_tmp21_ = uint64_try_parse (_tmp19_, &_tmp20_, NULL, (guint) 0);
#line 212 "../src/history.vala"
				test = _tmp20_;
#line 212 "../src/history.vala"
				if (!_tmp21_) {
#line 213 "../src/history.vala"
					_g_date_time_unref0 (date);
#line 213 "../src/history.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 213 "../src/history.vala"
					_g_free0 (line);
#line 213 "../src/history.vala"
					continue;
#line 1937 "history.c"
				}
#line 214 "../src/history.vala"
				if (test < ((guint64) 2)) {
#line 214 "../src/history.vala"
					_tmp22_ = TRUE;
#line 1943 "history.c"
				} else {
#line 214 "../src/history.vala"
					_tmp22_ = test > ((guint64) 6);
#line 1947 "history.c"
				}
#line 214 "../src/history.vala"
				if (_tmp22_) {
#line 215 "../src/history.vala"
					_g_date_time_unref0 (date);
#line 215 "../src/history.vala"
					tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 215 "../src/history.vala"
					_g_free0 (line);
#line 215 "../src/history.vala"
					continue;
#line 1959 "history.c"
				}
#line 216 "../src/history.vala"
				size = (guint8) test;
#line 220 "../src/history.vala"
				_tmp23_ = tokens;
#line 220 "../src/history.vala"
				_tmp23__length1 = tokens_length1;
#line 220 "../src/history.vala"
				_tmp24_ = _tmp23_[2];
#line 220 "../src/history.vala"
				_tmp26_ = uint64_try_parse (_tmp24_, &_tmp25_, NULL, (guint) 0);
#line 220 "../src/history.vala"
				duration = (gdouble) _tmp25_;
#line 220 "../src/history.vala"
				if (_tmp26_) {
#line 221 "../src/history.vala"
					int_duration = TRUE;
#line 1977 "history.c"
				} else {
					gchar** _tmp27_;
					gint _tmp27__length1;
					const gchar* _tmp28_;
					gdouble _tmp29_ = 0.0;
					gboolean _tmp30_;
#line 222 "../src/history.vala"
					_tmp27_ = tokens;
#line 222 "../src/history.vala"
					_tmp27__length1 = tokens_length1;
#line 222 "../src/history.vala"
					_tmp28_ = _tmp27_[2];
#line 222 "../src/history.vala"
					_tmp30_ = double_try_parse (_tmp28_, &_tmp29_, NULL);
#line 222 "../src/history.vala"
					duration = _tmp29_;
#line 222 "../src/history.vala"
					if (_tmp30_) {
#line 223 "../src/history.vala"
						int_duration = FALSE;
#line 1998 "history.c"
					} else {
#line 225 "../src/history.vala"
						_g_date_time_unref0 (date);
#line 225 "../src/history.vala"
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 225 "../src/history.vala"
						_g_free0 (line);
#line 225 "../src/history.vala"
						continue;
#line 2008 "history.c"
					}
				}
#line 227 "../src/history.vala"
				_tmp31_ = date;
#line 227 "../src/history.vala"
				_tmp32_ = history_entry_new ((GDateTime*) _tmp31_, size, duration, int_duration);
#line 227 "../src/history.vala"
				self->entries = g_list_prepend (self->entries, _tmp32_);
#line 201 "../src/history.vala"
				_g_date_time_unref0 (date);
#line 201 "../src/history.vala"
				tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
#line 201 "../src/history.vala"
				_g_free0 (line);
#line 2023 "history.c"
			}
		}
#line 201 "../src/history.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2028 "history.c"
	}
#line 229 "../src/history.vala"
	self->entries = g_list_sort (self->entries, _history_compare_entries_gcompare_func);
#line 187 "../src/history.vala"
	_g_free0 (contents);
#line 2034 "history.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3365 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3366 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3366 "glib-2.0.vapi"
	result = _tmp0_;
#line 3366 "glib-2.0.vapi"
	return result;
#line 2050 "history.c"
}

static gchar*
double_to_string (gdouble self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 997 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 997 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 997 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 997 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, (gint) G_ASCII_DTOSTR_BUF_SIZE, self);
#line 997 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 997 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 997 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 997 "glib-2.0.vapi"
	result = _tmp4_;
#line 997 "glib-2.0.vapi"
	return result;
#line 2081 "history.c"
}

static inline void
history_save (History* self)
{
	gchar* contents = NULL;
	gchar* _tmp0_;
	GList* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 236 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/history.vala"
	_tmp0_ = g_strdup ("");
#line 238 "../src/history.vala"
	contents = _tmp0_;
#line 240 "../src/history.vala"
	_tmp1_ = self->entries;
#line 2099 "history.c"
	{
		GList* entry_collection = NULL;
		GList* entry_it = NULL;
#line 240 "../src/history.vala"
		entry_collection = _tmp1_;
#line 240 "../src/history.vala"
		for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
#line 2107 "history.c"
			HistoryEntry* _tmp2_;
			HistoryEntry* entry = NULL;
#line 240 "../src/history.vala"
			_tmp2_ = _g_object_ref0 ((HistoryEntry*) entry_it->data);
#line 240 "../src/history.vala"
			entry = _tmp2_;
#line 2114 "history.c"
			{
				gchar* line = NULL;
				HistoryEntry* _tmp3_;
				gboolean _tmp4_;
				gboolean _tmp5_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gchar* _tmp34_;
#line 243 "../src/history.vala"
				_tmp3_ = entry;
#line 243 "../src/history.vala"
				_tmp4_ = history_entry_get_int_duration (_tmp3_);
#line 243 "../src/history.vala"
				_tmp5_ = _tmp4_;
#line 243 "../src/history.vala"
				if (_tmp5_) {
#line 2131 "history.c"
					HistoryEntry* _tmp6_;
					GDateTime* _tmp7_;
					GDateTime* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					HistoryEntry* _tmp11_;
					guint8 _tmp12_;
					guint8 _tmp13_;
					HistoryEntry* _tmp14_;
					gdouble _tmp15_;
					gdouble _tmp16_;
					gchar* _tmp17_;
#line 244 "../src/history.vala"
					_tmp6_ = entry;
#line 244 "../src/history.vala"
					_tmp7_ = history_entry_get_date (_tmp6_);
#line 244 "../src/history.vala"
					_tmp8_ = _tmp7_;
#line 244 "../src/history.vala"
					_tmp9_ = g_date_time_to_string (_tmp8_);
#line 244 "../src/history.vala"
					_tmp10_ = _tmp9_;
#line 244 "../src/history.vala"
					_tmp11_ = entry;
#line 244 "../src/history.vala"
					_tmp12_ = history_entry_get_size (_tmp11_);
#line 244 "../src/history.vala"
					_tmp13_ = _tmp12_;
#line 244 "../src/history.vala"
					_tmp14_ = entry;
#line 244 "../src/history.vala"
					_tmp15_ = history_entry_get_duration (_tmp14_);
#line 244 "../src/history.vala"
					_tmp16_ = _tmp15_;
#line 244 "../src/history.vala"
					_tmp17_ = g_strdup_printf ("%s %hu %u\n", _tmp10_, (gushort) _tmp13_, (guint) _tmp16_);
#line 244 "../src/history.vala"
					_g_free0 (line);
#line 244 "../src/history.vala"
					line = _tmp17_;
#line 244 "../src/history.vala"
					_g_free0 (_tmp10_);
#line 2174 "history.c"
				} else {
					HistoryEntry* _tmp18_;
					GDateTime* _tmp19_;
					GDateTime* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					HistoryEntry* _tmp23_;
					guint8 _tmp24_;
					guint8 _tmp25_;
					HistoryEntry* _tmp26_;
					gdouble _tmp27_;
					gdouble _tmp28_;
					gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
#line 246 "../src/history.vala"
					_tmp18_ = entry;
#line 246 "../src/history.vala"
					_tmp19_ = history_entry_get_date (_tmp18_);
#line 246 "../src/history.vala"
					_tmp20_ = _tmp19_;
#line 246 "../src/history.vala"
					_tmp21_ = g_date_time_to_string (_tmp20_);
#line 246 "../src/history.vala"
					_tmp22_ = _tmp21_;
#line 246 "../src/history.vala"
					_tmp23_ = entry;
#line 246 "../src/history.vala"
					_tmp24_ = history_entry_get_size (_tmp23_);
#line 246 "../src/history.vala"
					_tmp25_ = _tmp24_;
#line 246 "../src/history.vala"
					_tmp26_ = entry;
#line 246 "../src/history.vala"
					_tmp27_ = history_entry_get_duration (_tmp26_);
#line 246 "../src/history.vala"
					_tmp28_ = _tmp27_;
#line 246 "../src/history.vala"
					_tmp29_ = double_to_string (_tmp28_);
#line 246 "../src/history.vala"
					_tmp30_ = _tmp29_;
#line 246 "../src/history.vala"
					_tmp31_ = g_strdup_printf ("%s %hu %s\n", _tmp22_, (gushort) _tmp25_, _tmp30_);
#line 246 "../src/history.vala"
					_g_free0 (line);
#line 246 "../src/history.vala"
					line = _tmp31_;
#line 246 "../src/history.vala"
					_g_free0 (_tmp30_);
#line 246 "../src/history.vala"
					_g_free0 (_tmp22_);
#line 2226 "history.c"
				}
#line 247 "../src/history.vala"
				_tmp32_ = contents;
#line 247 "../src/history.vala"
				_tmp33_ = line;
#line 247 "../src/history.vala"
				_tmp34_ = g_strconcat (_tmp32_, _tmp33_, NULL);
#line 247 "../src/history.vala"
				_g_free0 (contents);
#line 247 "../src/history.vala"
				contents = _tmp34_;
#line 240 "../src/history.vala"
				_g_free0 (line);
#line 240 "../src/history.vala"
				_g_object_unref0 (entry);
#line 2242 "history.c"
			}
		}
	}
	{
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
#line 252 "../src/history.vala"
		_tmp35_ = self->priv->_filename;
#line 252 "../src/history.vala"
		_tmp36_ = g_path_get_dirname (_tmp35_);
#line 252 "../src/history.vala"
		_tmp37_ = _tmp36_;
#line 252 "../src/history.vala"
		g_mkdir_with_parents (_tmp37_, 0775);
#line 252 "../src/history.vala"
		_g_free0 (_tmp37_);
#line 253 "../src/history.vala"
		_tmp38_ = self->priv->_filename;
#line 253 "../src/history.vala"
		_tmp39_ = contents;
#line 253 "../src/history.vala"
		g_file_set_contents (_tmp38_, _tmp39_, (gssize) -1, &_inner_error0_);
#line 253 "../src/history.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 253 "../src/history.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2272 "history.c"
				goto __catch0_g_file_error;
			}
#line 253 "../src/history.vala"
			_g_free0 (contents);
#line 253 "../src/history.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 253 "../src/history.vala"
			g_clear_error (&_inner_error0_);
#line 253 "../src/history.vala"
			return;
#line 2283 "history.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
		GError* e = NULL;
		GError* _tmp40_;
		const gchar* _tmp41_;
#line 250 "../src/history.vala"
		e = _inner_error0_;
#line 250 "../src/history.vala"
		_inner_error0_ = NULL;
#line 257 "../src/history.vala"
		_tmp40_ = e;
#line 257 "../src/history.vala"
		_tmp41_ = _tmp40_->message;
#line 257 "../src/history.vala"
		g_warning ("history.vala:257: Failed to save history: %s", _tmp41_);
#line 250 "../src/history.vala"
		_g_error_free0 (e);
#line 2304 "history.c"
	}
	__finally0:
#line 250 "../src/history.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../src/history.vala"
		_g_free0 (contents);
#line 250 "../src/history.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 250 "../src/history.vala"
		g_clear_error (&_inner_error0_);
#line 250 "../src/history.vala"
		return;
#line 2317 "history.c"
	}
#line 236 "../src/history.vala"
	_g_free0 (contents);
#line 2321 "history.c"
}

static gint
history_compare_entries (HistoryEntry* a,
                         HistoryEntry* b)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	gdouble _tmp33_;
	GDateTime* _tmp34_;
	GDateTime* _tmp35_;
	GDateTime* _tmp36_;
	GDateTime* _tmp37_;
	gint result;
#line 265 "../src/history.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 265 "../src/history.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 268 "../src/history.vala"
	_tmp0_ = history_entry_get_size (a);
#line 268 "../src/history.vala"
	_tmp1_ = _tmp0_;
#line 268 "../src/history.vala"
	_tmp2_ = history_entry_get_size (b);
#line 268 "../src/history.vala"
	_tmp3_ = _tmp2_;
#line 268 "../src/history.vala"
	if (_tmp1_ != _tmp3_) {
#line 2373 "history.c"
		guint8 _tmp4_;
		guint8 _tmp5_;
		guint8 _tmp6_;
		guint8 _tmp7_;
#line 269 "../src/history.vala"
		_tmp4_ = history_entry_get_size (a);
#line 269 "../src/history.vala"
		_tmp5_ = _tmp4_;
#line 269 "../src/history.vala"
		_tmp6_ = history_entry_get_size (b);
#line 269 "../src/history.vala"
		_tmp7_ = _tmp6_;
#line 269 "../src/history.vala"
		result = ((gint) _tmp5_) - ((gint) _tmp7_);
#line 269 "../src/history.vala"
		return result;
#line 2390 "history.c"
	}
#line 272 "../src/history.vala"
	_tmp8_ = history_entry_get_duration (a);
#line 272 "../src/history.vala"
	_tmp9_ = _tmp8_;
#line 272 "../src/history.vala"
	_tmp10_ = history_entry_get_duration (b);
#line 272 "../src/history.vala"
	_tmp11_ = _tmp10_;
#line 272 "../src/history.vala"
	if (((guint) _tmp9_) < ((guint) _tmp11_)) {
#line 273 "../src/history.vala"
		result = -1;
#line 273 "../src/history.vala"
		return result;
#line 2406 "history.c"
	}
#line 274 "../src/history.vala"
	_tmp12_ = history_entry_get_duration (a);
#line 274 "../src/history.vala"
	_tmp13_ = _tmp12_;
#line 274 "../src/history.vala"
	_tmp14_ = history_entry_get_duration (b);
#line 274 "../src/history.vala"
	_tmp15_ = _tmp14_;
#line 274 "../src/history.vala"
	if (((guint) _tmp13_) > ((guint) _tmp15_)) {
#line 275 "../src/history.vala"
		result = 1;
#line 275 "../src/history.vala"
		return result;
#line 2422 "history.c"
	}
#line 278 "../src/history.vala"
	_tmp17_ = history_entry_get_int_duration (a);
#line 278 "../src/history.vala"
	_tmp18_ = _tmp17_;
#line 278 "../src/history.vala"
	if (_tmp18_) {
#line 2430 "history.c"
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 278 "../src/history.vala"
		_tmp19_ = history_entry_get_int_duration (b);
#line 278 "../src/history.vala"
		_tmp20_ = _tmp19_;
#line 278 "../src/history.vala"
		_tmp16_ = !_tmp20_;
#line 2439 "history.c"
	} else {
#line 278 "../src/history.vala"
		_tmp16_ = FALSE;
#line 2443 "history.c"
	}
#line 278 "../src/history.vala"
	if (_tmp16_) {
#line 279 "../src/history.vala"
		result = 1;
#line 279 "../src/history.vala"
		return result;
#line 2451 "history.c"
	}
#line 280 "../src/history.vala"
	_tmp22_ = history_entry_get_int_duration (b);
#line 280 "../src/history.vala"
	_tmp23_ = _tmp22_;
#line 280 "../src/history.vala"
	if (_tmp23_) {
#line 2459 "history.c"
		gboolean _tmp24_;
		gboolean _tmp25_;
#line 280 "../src/history.vala"
		_tmp24_ = history_entry_get_int_duration (a);
#line 280 "../src/history.vala"
		_tmp25_ = _tmp24_;
#line 280 "../src/history.vala"
		_tmp21_ = !_tmp25_;
#line 2468 "history.c"
	} else {
#line 280 "../src/history.vala"
		_tmp21_ = FALSE;
#line 2472 "history.c"
	}
#line 280 "../src/history.vala"
	if (_tmp21_) {
#line 281 "../src/history.vala"
		result = -1;
#line 281 "../src/history.vala"
		return result;
#line 2480 "history.c"
	}
#line 284 "../src/history.vala"
	_tmp26_ = history_entry_get_duration (a);
#line 284 "../src/history.vala"
	_tmp27_ = _tmp26_;
#line 284 "../src/history.vala"
	_tmp28_ = history_entry_get_duration (b);
#line 284 "../src/history.vala"
	_tmp29_ = _tmp28_;
#line 284 "../src/history.vala"
	if (_tmp27_ < _tmp29_) {
#line 285 "../src/history.vala"
		result = -1;
#line 285 "../src/history.vala"
		return result;
#line 2496 "history.c"
	}
#line 286 "../src/history.vala"
	_tmp30_ = history_entry_get_duration (a);
#line 286 "../src/history.vala"
	_tmp31_ = _tmp30_;
#line 286 "../src/history.vala"
	_tmp32_ = history_entry_get_duration (b);
#line 286 "../src/history.vala"
	_tmp33_ = _tmp32_;
#line 286 "../src/history.vala"
	if (_tmp31_ > _tmp33_) {
#line 287 "../src/history.vala"
		result = 1;
#line 287 "../src/history.vala"
		return result;
#line 2512 "history.c"
	}
#line 290 "../src/history.vala"
	_tmp34_ = history_entry_get_date (a);
#line 290 "../src/history.vala"
	_tmp35_ = _tmp34_;
#line 290 "../src/history.vala"
	_tmp36_ = history_entry_get_date (b);
#line 290 "../src/history.vala"
	_tmp37_ = _tmp36_;
#line 290 "../src/history.vala"
	result = -1 * g_date_time_compare (_tmp35_, _tmp37_);
#line 290 "../src/history.vala"
	return result;
#line 2526 "history.c"
}

static const gchar*
history_get_filename (History* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 24 "../src/history.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/history.vala"
	_tmp0_ = self->priv->_filename;
#line 24 "../src/history.vala"
	result = _tmp0_;
#line 24 "../src/history.vala"
	return result;
#line 2542 "history.c"
}

static void
history_set_filename (History* self,
                      const gchar* value)
{
	gchar* _tmp0_;
#line 24 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/history.vala"
	_tmp0_ = g_strdup (value);
#line 24 "../src/history.vala"
	_g_free0 (self->priv->_filename);
#line 24 "../src/history.vala"
	self->priv->_filename = _tmp0_;
#line 2558 "history.c"
}

static void
history_class_init (HistoryClass * klass,
                    gpointer klass_data)
{
#line 22 "../src/history.vala"
	history_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/history.vala"
	g_type_class_adjust_private_offset (klass, &History_private_offset);
#line 22 "../src/history.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_history_get_property;
#line 22 "../src/history.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_history_set_property;
#line 22 "../src/history.vala"
	G_OBJECT_CLASS (klass)->finalize = history_finalize;
#line 22 "../src/history.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_FILENAME_PROPERTY, history_properties[HISTORY_FILENAME_PROPERTY] = g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 22 "../src/history.vala"
	history_signals[HISTORY_ENTRY_ADDED_SIGNAL] = g_signal_new ("entry-added", TYPE_HISTORY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_HISTORY_ENTRY);
#line 2579 "history.c"
}

static void
history_instance_init (History * self,
                       gpointer klass)
{
#line 22 "../src/history.vala"
	self->priv = history_get_instance_private (self);
#line 25 "../src/history.vala"
	self->entries = NULL;
#line 2590 "history.c"
}

static void
history_finalize (GObject * obj)
{
	History * self;
#line 22 "../src/history.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY, History);
#line 24 "../src/history.vala"
	_g_free0 (self->priv->_filename);
#line 25 "../src/history.vala"
	(self->entries == NULL) ? NULL : (self->entries = (_g_list_free__g_object_unref0_ (self->entries), NULL));
#line 22 "../src/history.vala"
	G_OBJECT_CLASS (history_parent_class)->finalize (obj);
#line 2605 "history.c"
}

static GType
history_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HistoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) history_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (History), 0, (GInstanceInitFunc) history_instance_init, NULL };
	GType history_type_id;
	history_type_id = g_type_register_static (G_TYPE_OBJECT, "History", &g_define_type_info, 0);
	History_private_offset = g_type_add_instance_private (history_type_id, sizeof (HistoryPrivate));
	return history_type_id;
}

GType
history_get_type (void)
{
	static volatile gsize history_type_id__once = 0;
	if (g_once_init_enter (&history_type_id__once)) {
		GType history_type_id;
		history_type_id = history_get_type_once ();
		g_once_init_leave (&history_type_id__once, history_type_id);
	}
	return history_type_id__once;
}

static void
_vala_history_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	History * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY, History);
#line 22 "../src/history.vala"
	switch (property_id) {
#line 22 "../src/history.vala"
		case HISTORY_FILENAME_PROPERTY:
#line 22 "../src/history.vala"
		g_value_set_string (value, history_get_filename (self));
#line 22 "../src/history.vala"
		break;
#line 2646 "history.c"
		default:
#line 22 "../src/history.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/history.vala"
		break;
#line 2652 "history.c"
	}
}

static void
_vala_history_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	History * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY, History);
#line 22 "../src/history.vala"
	switch (property_id) {
#line 22 "../src/history.vala"
		case HISTORY_FILENAME_PROPERTY:
#line 22 "../src/history.vala"
		history_set_filename (self, g_value_get_string (value));
#line 22 "../src/history.vala"
		break;
#line 2672 "history.c"
		default:
#line 22 "../src/history.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/history.vala"
		break;
#line 2678 "history.c"
	}
}

static inline gpointer
history_entry_get_instance_private (HistoryEntry* self)
{
	return G_STRUCT_MEMBER_P (self, HistoryEntry_private_offset);
}

HistoryEntry*
history_entry_construct (GType object_type,
                         GDateTime* date,
                         guint8 size,
                         gdouble duration,
                         gboolean int_duration)
{
	HistoryEntry * self = NULL;
#line 301 "../src/history.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 303 "../src/history.vala"
	self = (HistoryEntry*) g_object_new (object_type, "date", date, "size", size, "duration", duration, "int-duration", int_duration, NULL);
#line 301 "../src/history.vala"
	return self;
#line 2702 "history.c"
}

HistoryEntry*
history_entry_new (GDateTime* date,
                   guint8 size,
                   gdouble duration,
                   gboolean int_duration)
{
#line 301 "../src/history.vala"
	return history_entry_construct (TYPE_HISTORY_ENTRY, date, size, duration, int_duration);
#line 2713 "history.c"
}

gchar*
history_entry_get_duration_string (HistoryEntry* entry)
{
	gdouble _tmp0_;
	gdouble _tmp5_;
	gchar* result;
#line 310 "../src/history.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 312 "../src/history.vala"
	_tmp0_ = entry->priv->_duration;
#line 312 "../src/history.vala"
	if (_tmp0_ >= 3600.0) {
#line 2728 "history.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gdouble _tmp3_;
		gchar* _tmp4_;
#line 314 "../src/history.vala"
		_tmp1_ = entry->priv->_duration;
#line 314 "../src/history.vala"
		_tmp2_ = entry->priv->_duration;
#line 314 "../src/history.vala"
		_tmp3_ = entry->priv->_duration;
#line 314 "../src/history.vala"
		_tmp4_ = g_strdup_printf (_ ("%uh %um %us"), ((guint) _tmp1_) / 3600, (((guint) _tmp2_) / 60) % 60, ((guint) _tmp3_) % 60);
#line 314 "../src/history.vala"
		result = _tmp4_;
#line 314 "../src/history.vala"
		return result;
#line 2745 "history.c"
	}
#line 316 "../src/history.vala"
	_tmp5_ = entry->priv->_duration;
#line 316 "../src/history.vala"
	if (_tmp5_ >= 60.0) {
#line 2751 "history.c"
		gdouble _tmp6_;
		gdouble _tmp7_;
		gchar* _tmp8_;
#line 318 "../src/history.vala"
		_tmp6_ = entry->priv->_duration;
#line 318 "../src/history.vala"
		_tmp7_ = entry->priv->_duration;
#line 318 "../src/history.vala"
		_tmp8_ = g_strdup_printf (_ ("%um %us"), ((guint) _tmp6_) / 60, ((guint) _tmp7_) % 60);
#line 318 "../src/history.vala"
		result = _tmp8_;
#line 318 "../src/history.vala"
		return result;
#line 2765 "history.c"
	} else {
		gboolean _tmp9_;
#line 320 "../src/history.vala"
		_tmp9_ = entry->priv->_int_duration;
#line 320 "../src/history.vala"
		if (_tmp9_) {
#line 2772 "history.c"
			gdouble _tmp10_;
			gchar* _tmp11_;
#line 322 "../src/history.vala"
			_tmp10_ = entry->priv->_duration;
#line 322 "../src/history.vala"
			_tmp11_ = g_strdup_printf (_ ("%us"), (guint) _tmp10_);
#line 322 "../src/history.vala"
			result = _tmp11_;
#line 322 "../src/history.vala"
			return result;
#line 2783 "history.c"
		} else {
			gdouble _tmp12_;
#line 324 "../src/history.vala"
			_tmp12_ = entry->priv->_duration;
#line 324 "../src/history.vala"
			if (_tmp12_ >= 20.0) {
#line 2790 "history.c"
				gdouble _tmp13_;
				gchar* _tmp14_;
#line 326 "../src/history.vala"
				_tmp13_ = entry->priv->_duration;
#line 326 "../src/history.vala"
				_tmp14_ = g_strdup_printf (_ ("%.0fs"), floor (_tmp13_));
#line 326 "../src/history.vala"
				result = _tmp14_;
#line 326 "../src/history.vala"
				return result;
#line 2801 "history.c"
			} else {
				gdouble _tmp15_;
#line 328 "../src/history.vala"
				_tmp15_ = entry->priv->_duration;
#line 328 "../src/history.vala"
				if (_tmp15_ >= 10.0) {
#line 2808 "history.c"
					gdouble _tmp16_;
					gchar* _tmp17_;
#line 330 "../src/history.vala"
					_tmp16_ = entry->priv->_duration;
#line 330 "../src/history.vala"
					_tmp17_ = g_strdup_printf (_ ("%.1fs"), floor (_tmp16_ * 10.0) / 10.0);
#line 330 "../src/history.vala"
					result = _tmp17_;
#line 330 "../src/history.vala"
					return result;
#line 2819 "history.c"
				} else {
					gdouble _tmp18_;
#line 332 "../src/history.vala"
					_tmp18_ = entry->priv->_duration;
#line 332 "../src/history.vala"
					if (_tmp18_ >= 5.0) {
#line 2826 "history.c"
						gdouble _tmp19_;
						gchar* _tmp20_;
#line 334 "../src/history.vala"
						_tmp19_ = entry->priv->_duration;
#line 334 "../src/history.vala"
						_tmp20_ = g_strdup_printf (_ ("%.2fs"), floor (_tmp19_ * 100.0) / 100.0);
#line 334 "../src/history.vala"
						result = _tmp20_;
#line 334 "../src/history.vala"
						return result;
#line 2837 "history.c"
					} else {
						gdouble _tmp21_;
						gchar* _tmp22_;
#line 338 "../src/history.vala"
						_tmp21_ = entry->priv->_duration;
#line 338 "../src/history.vala"
						_tmp22_ = g_strdup_printf (_ ("%.3fs"), floor (_tmp21_ * 1000.0) / 1000.0);
#line 338 "../src/history.vala"
						result = _tmp22_;
#line 338 "../src/history.vala"
						return result;
#line 2849 "history.c"
					}
				}
			}
		}
	}
}

GDateTime*
history_entry_get_date (HistoryEntry* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 296 "../src/history.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "../src/history.vala"
	_tmp0_ = self->priv->_date;
#line 296 "../src/history.vala"
	result = _tmp0_;
#line 296 "../src/history.vala"
	return result;
#line 2870 "history.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 296 "../src/history.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 2878 "history.c"
}

static void
history_entry_set_date (HistoryEntry* self,
                        GDateTime* value)
{
	GDateTime* _tmp0_;
#line 296 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/history.vala"
	_tmp0_ = _g_date_time_ref0 (value);
#line 296 "../src/history.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 296 "../src/history.vala"
	self->priv->_date = _tmp0_;
#line 2894 "history.c"
}

guint8
history_entry_get_size (HistoryEntry* self)
{
	guint8 result;
#line 297 "../src/history.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 297 "../src/history.vala"
	result = self->priv->_size;
#line 297 "../src/history.vala"
	return result;
#line 2907 "history.c"
}

static void
history_entry_set_size (HistoryEntry* self,
                        guint8 value)
{
#line 297 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/history.vala"
	self->priv->_size = value;
#line 2918 "history.c"
}

gdouble
history_entry_get_duration (HistoryEntry* self)
{
	gdouble result;
#line 298 "../src/history.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 298 "../src/history.vala"
	result = self->priv->_duration;
#line 298 "../src/history.vala"
	return result;
#line 2931 "history.c"
}

static void
history_entry_set_duration (HistoryEntry* self,
                            gdouble value)
{
#line 298 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 298 "../src/history.vala"
	self->priv->_duration = value;
#line 2942 "history.c"
}

gboolean
history_entry_get_int_duration (HistoryEntry* self)
{
	gboolean result;
#line 299 "../src/history.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 299 "../src/history.vala"
	result = self->priv->_int_duration;
#line 299 "../src/history.vala"
	return result;
#line 2955 "history.c"
}

static void
history_entry_set_int_duration (HistoryEntry* self,
                                gboolean value)
{
#line 299 "../src/history.vala"
	g_return_if_fail (self != NULL);
#line 299 "../src/history.vala"
	self->priv->_int_duration = value;
#line 2966 "history.c"
}

static void
history_entry_class_init (HistoryEntryClass * klass,
                          gpointer klass_data)
{
#line 294 "../src/history.vala"
	history_entry_parent_class = g_type_class_peek_parent (klass);
#line 294 "../src/history.vala"
	g_type_class_adjust_private_offset (klass, &HistoryEntry_private_offset);
#line 294 "../src/history.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_history_entry_get_property;
#line 294 "../src/history.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_history_entry_set_property;
#line 294 "../src/history.vala"
	G_OBJECT_CLASS (klass)->finalize = history_entry_finalize;
#line 294 "../src/history.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_ENTRY_DATE_PROPERTY, history_entry_properties[HISTORY_ENTRY_DATE_PROPERTY] = g_param_spec_boxed ("date", "date", "date", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 294 "../src/history.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_ENTRY_SIZE_PROPERTY, history_entry_properties[HISTORY_ENTRY_SIZE_PROPERTY] = g_param_spec_uchar ("size", "size", "size", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 294 "../src/history.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_ENTRY_DURATION_PROPERTY, history_entry_properties[HISTORY_ENTRY_DURATION_PROPERTY] = g_param_spec_double ("duration", "duration", "duration", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 294 "../src/history.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), HISTORY_ENTRY_INT_DURATION_PROPERTY, history_entry_properties[HISTORY_ENTRY_INT_DURATION_PROPERTY] = g_param_spec_boolean ("int-duration", "int-duration", "int-duration", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY | G_PARAM_EXPLICIT_NOTIFY));
#line 2991 "history.c"
}

static void
history_entry_instance_init (HistoryEntry * self,
                             gpointer klass)
{
#line 294 "../src/history.vala"
	self->priv = history_entry_get_instance_private (self);
#line 3000 "history.c"
}

static void
history_entry_finalize (GObject * obj)
{
	HistoryEntry * self;
#line 294 "../src/history.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HISTORY_ENTRY, HistoryEntry);
#line 296 "../src/history.vala"
	_g_date_time_unref0 (self->priv->_date);
#line 294 "../src/history.vala"
	G_OBJECT_CLASS (history_entry_parent_class)->finalize (obj);
#line 3013 "history.c"
}

static GType
history_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HistoryEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) history_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HistoryEntry), 0, (GInstanceInitFunc) history_entry_instance_init, NULL };
	GType history_entry_type_id;
	history_entry_type_id = g_type_register_static (G_TYPE_OBJECT, "HistoryEntry", &g_define_type_info, 0);
	HistoryEntry_private_offset = g_type_add_instance_private (history_entry_type_id, sizeof (HistoryEntryPrivate));
	return history_entry_type_id;
}

GType
history_entry_get_type (void)
{
	static volatile gsize history_entry_type_id__once = 0;
	if (g_once_init_enter (&history_entry_type_id__once)) {
		GType history_entry_type_id;
		history_entry_type_id = history_entry_get_type_once ();
		g_once_init_leave (&history_entry_type_id__once, history_entry_type_id);
	}
	return history_entry_type_id__once;
}

static void
_vala_history_entry_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HistoryEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY_ENTRY, HistoryEntry);
#line 294 "../src/history.vala"
	switch (property_id) {
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_DATE_PROPERTY:
#line 294 "../src/history.vala"
		g_value_set_boxed (value, history_entry_get_date (self));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_SIZE_PROPERTY:
#line 294 "../src/history.vala"
		g_value_set_uchar (value, history_entry_get_size (self));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_DURATION_PROPERTY:
#line 294 "../src/history.vala"
		g_value_set_double (value, history_entry_get_duration (self));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_INT_DURATION_PROPERTY:
#line 294 "../src/history.vala"
		g_value_set_boolean (value, history_entry_get_int_duration (self));
#line 294 "../src/history.vala"
		break;
#line 3072 "history.c"
		default:
#line 294 "../src/history.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 294 "../src/history.vala"
		break;
#line 3078 "history.c"
	}
}

static void
_vala_history_entry_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	HistoryEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HISTORY_ENTRY, HistoryEntry);
#line 294 "../src/history.vala"
	switch (property_id) {
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_DATE_PROPERTY:
#line 294 "../src/history.vala"
		history_entry_set_date (self, g_value_get_boxed (value));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_SIZE_PROPERTY:
#line 294 "../src/history.vala"
		history_entry_set_size (self, g_value_get_uchar (value));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_DURATION_PROPERTY:
#line 294 "../src/history.vala"
		history_entry_set_duration (self, g_value_get_double (value));
#line 294 "../src/history.vala"
		break;
#line 294 "../src/history.vala"
		case HISTORY_ENTRY_INT_DURATION_PROPERTY:
#line 294 "../src/history.vala"
		history_entry_set_int_duration (self, g_value_get_boolean (value));
#line 294 "../src/history.vala"
		break;
#line 3116 "history.c"
		default:
#line 294 "../src/history.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 294 "../src/history.vala"
		break;
#line 3122 "history.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

