/* theme-neoretro.c generated by valac 0.56.14, the Vala compiler
 * generated from theme-neoretro.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-

   This file is part of GNOME Tetravex.

   Copyright (C) 2019 Arnaud Bonatti

   GNOME Tetravex is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 2 of the License, or
   (at your option) any later version.

   GNOME Tetravex is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with this GNOME Tetravex.  If not, see <https://www.gnu.org/licenses/>.
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define NEO_RETRO_THEME_HALF_PI G_PI_2
#define PUZZLE_VIEW_gap_factor 0.5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;

#define TYPE_NEO_RETRO_THEME (neo_retro_theme_get_type ())
#define NEO_RETRO_THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEO_RETRO_THEME, NeoRetroTheme))
#define NEO_RETRO_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEO_RETRO_THEME, NeoRetroThemeClass))
#define IS_NEO_RETRO_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEO_RETRO_THEME))
#define IS_NEO_RETRO_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEO_RETRO_THEME))
#define NEO_RETRO_THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEO_RETRO_THEME, NeoRetroThemeClass))

typedef struct _NeoRetroTheme NeoRetroTheme;
typedef struct _NeoRetroThemeClass NeoRetroThemeClass;
typedef struct _NeoRetroThemePrivate NeoRetroThemePrivate;
enum  {
	NEO_RETRO_THEME_0_PROPERTY,
	NEO_RETRO_THEME_NUM_PROPERTIES
};
static GParamSpec* neo_retro_theme_properties[NEO_RETRO_THEME_NUM_PROPERTIES];
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
typedef struct _TilePrivate TilePrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
	void (*configure) (Theme* self, guint size);
	void (*draw_arrow) (Theme* self, cairo_t* context);
	void (*draw_socket) (Theme* self, cairo_t* context);
	void (*draw_highlight) (Theme* self, cairo_t* context, gboolean has_tile);
	void (*draw_paused_tile) (Theme* self, cairo_t* context);
	void (*draw_tile) (Theme* self, cairo_t* context, Tile* tile, gboolean highlight);
	void (*set_animation_level) (Theme* self, guint8 animation_level);
};

struct _NeoRetroTheme {
	Theme parent_instance;
	NeoRetroThemePrivate * priv;
};

struct _NeoRetroThemeClass {
	ThemeClass parent_class;
};

struct _NeoRetroThemePrivate {
	cairo_pattern_t* tile_colors_h[10];
	cairo_pattern_t* tile_colors_v[10];
	cairo_pattern_t* tile_highlights_h[10];
	cairo_pattern_t* tile_highlights_v[10];
	cairo_pattern_t* text_colors[10];
	cairo_pattern_t* black_text_color;
	cairo_pattern_t* white_text_color;
	cairo_pattern_t* paused_color_h;
	cairo_pattern_t* paused_color_v;
	guint size;
	guint8 animation_level;
	gdouble arrow_half_h;
	gdouble neg_arrow_half_h;
	gdouble arrow_w;
	gdouble arrow_x;
	gdouble arrow_clip_x;
	gdouble arrow_clip_y;
	gdouble arrow_clip_w;
	gdouble arrow_clip_h;
	gdouble arrow_border_opacity;
	gdouble arrow_fill_opacity;
	guint socket_margin;
	gint socket_size;
	cairo_pattern_t* socket_pattern;
	cairo_matrix_t matrix;
	cairo_pattern_t* highlight_tile_pattern;
	guint tile_margin;
	gint tile_size;
	gdouble half_tile_size;
	gdouble font_size;
	gdouble north_number_y;
	gdouble south_number_y;
	gdouble east_number_x;
	gdouble west_number_x;
};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	guint8 north;
	guint8 west;
	guint8 east;
	guint8 south;
};

struct _TileClass {
	GObjectClass parent_class;
};

static gint NeoRetroTheme_private_offset;
static gpointer neo_retro_theme_parent_class = NULL;

VALA_EXTERN GType theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Theme, g_object_unref)
VALA_EXTERN GType tile_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
VALA_EXTERN GType neo_retro_theme_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NeoRetroTheme, g_object_unref)
VALA_EXTERN void theme_configure (Theme* self,
                      guint size);
VALA_EXTERN void theme_set_animation_level (Theme* self,
                                guint8 animation_level);
VALA_EXTERN void theme_draw_arrow (Theme* self,
                       cairo_t* context);
VALA_EXTERN void theme_draw_socket (Theme* self,
                        cairo_t* context);
VALA_EXTERN void theme_draw_highlight (Theme* self,
                           cairo_t* context,
                           gboolean has_tile);
VALA_EXTERN void theme_draw_paused_tile (Theme* self,
                             cairo_t* context);
VALA_EXTERN void theme_draw_tile (Theme* self,
                      cairo_t* context,
                      Tile* tile,
                      gboolean highlight);
static void neo_retro_theme_make_color_pattern (NeoRetroTheme* self,
                                         guint position,
                                         const gchar* color,
                                         gboolean white_text);
static cairo_pattern_t* neo_retro_theme_make_dir_color_pattern (const gchar* color,
                                                         gboolean vertical,
                                                         gdouble color_factor);
static gdouble neo_retro_theme_hex_value (gchar c);
static void neo_retro_theme_real_configure (Theme* base,
                                     guint new_size);
static void neo_retro_theme_init_socket_pattern (NeoRetroTheme* self);
static void neo_retro_theme_real_set_animation_level (Theme* base,
                                               guint8 new_animation_level);
static void neo_retro_theme_real_draw_arrow (Theme* base,
                                      cairo_t* context);
static void neo_retro_theme_real_draw_socket (Theme* base,
                                       cairo_t* context);
static void neo_retro_theme_rounded_square (cairo_t* context,
                                     gdouble x,
                                     gdouble y,
                                     gint size,
                                     gdouble radius_percent);
static void neo_retro_theme_real_draw_highlight (Theme* base,
                                          cairo_t* context,
                                          gboolean has_tile);
static void neo_retro_theme_real_draw_paused_tile (Theme* base,
                                            cairo_t* context);
static void neo_retro_theme_draw_tile_background (NeoRetroTheme* self,
                                           cairo_t* context,
                                           cairo_pattern_t* north_color,
                                           cairo_pattern_t* east_color,
                                           cairo_pattern_t* south_color,
                                           cairo_pattern_t* west_color);
static void neo_retro_theme_real_draw_tile (Theme* base,
                                     cairo_t* context,
                                     Tile* tile,
                                     gboolean highlight);
static void neo_retro_theme_draw_number (cairo_t* context,
                                  cairo_pattern_t* text_color,
                                  gdouble x,
                                  gdouble y,
                                  guint8 number);
VALA_EXTERN NeoRetroTheme* neo_retro_theme_new (void);
VALA_EXTERN NeoRetroTheme* neo_retro_theme_construct (GType object_type);
VALA_EXTERN Theme* theme_construct (GType object_type);
static GObject * neo_retro_theme_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void neo_retro_theme_finalize (GObject * obj);
static GType neo_retro_theme_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
neo_retro_theme_get_instance_private (NeoRetroTheme* self)
{
	return G_STRUCT_MEMBER_P (self, NeoRetroTheme_private_offset);
}

static void
neo_retro_theme_make_color_pattern (NeoRetroTheme* self,
                                    guint position,
                                    const gchar* color,
                                    gboolean white_text)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
#line 56 "../src/theme-neoretro.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/theme-neoretro.vala"
	g_return_if_fail (color != NULL);
#line 58 "../src/theme-neoretro.vala"
	_tmp0_ = neo_retro_theme_make_dir_color_pattern (color, FALSE, 1.0);
#line 58 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors_h[position]);
#line 58 "../src/theme-neoretro.vala"
	self->priv->tile_colors_h[position] = _tmp0_;
#line 59 "../src/theme-neoretro.vala"
	_tmp1_ = neo_retro_theme_make_dir_color_pattern (color, TRUE, 1.0);
#line 59 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->tile_colors_v[position]);
#line 59 "../src/theme-neoretro.vala"
	self->priv->tile_colors_v[position] = _tmp1_;
#line 60 "../src/theme-neoretro.vala"
	_tmp2_ = neo_retro_theme_make_dir_color_pattern (color, FALSE, 1.4);
#line 60 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->tile_highlights_h[position]);
#line 60 "../src/theme-neoretro.vala"
	self->priv->tile_highlights_h[position] = _tmp2_;
#line 61 "../src/theme-neoretro.vala"
	_tmp3_ = neo_retro_theme_make_dir_color_pattern (color, TRUE, 1.4);
#line 61 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->tile_highlights_v[position]);
#line 61 "../src/theme-neoretro.vala"
	self->priv->tile_highlights_v[position] = _tmp3_;
#line 63 "../src/theme-neoretro.vala"
	if (white_text) {
#line 295 "theme-neoretro.c"
		cairo_pattern_t* _tmp4_;
#line 64 "../src/theme-neoretro.vala"
		_tmp4_ = self->priv->white_text_color;
#line 64 "../src/theme-neoretro.vala"
		self->priv->text_colors[position] = _tmp4_;
#line 301 "theme-neoretro.c"
	} else {
		cairo_pattern_t* _tmp5_;
#line 66 "../src/theme-neoretro.vala"
		_tmp5_ = self->priv->black_text_color;
#line 66 "../src/theme-neoretro.vala"
		self->priv->text_colors[position] = _tmp5_;
#line 308 "theme-neoretro.c"
	}
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 326 "theme-neoretro.c"
}

static cairo_pattern_t*
neo_retro_theme_make_dir_color_pattern (const gchar* color,
                                        gboolean vertical,
                                        gdouble color_factor)
{
	gdouble r0 = 0.0;
	gdouble g0 = 0.0;
	gdouble b0 = 0.0;
	gdouble r1 = 0.0;
	gdouble g1 = 0.0;
	gdouble b1 = 0.0;
	gdouble r2 = 0.0;
	gdouble g2 = 0.0;
	gdouble b2 = 0.0;
	gdouble r5 = 0.0;
	gdouble g5 = 0.0;
	gdouble b5 = 0.0;
	cairo_pattern_t* pattern = NULL;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* result;
#line 69 "../src/theme-neoretro.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 71 "../src/theme-neoretro.vala"
	r0 = (((neo_retro_theme_hex_value (string_get (color, (glong) 0)) * 16) + neo_retro_theme_hex_value (string_get (color, (glong) 1))) / 255.0) * color_factor;
#line 72 "../src/theme-neoretro.vala"
	g0 = (((neo_retro_theme_hex_value (string_get (color, (glong) 2)) * 16) + neo_retro_theme_hex_value (string_get (color, (glong) 3))) / 255.0) * color_factor;
#line 73 "../src/theme-neoretro.vala"
	b0 = (((neo_retro_theme_hex_value (string_get (color, (glong) 4)) * 16) + neo_retro_theme_hex_value (string_get (color, (glong) 5))) / 255.0) * color_factor;
#line 75 "../src/theme-neoretro.vala"
	r1 = MIN (r0 + 0.10, 1.0);
#line 76 "../src/theme-neoretro.vala"
	g1 = MIN (g0 + 0.10, 1.0);
#line 77 "../src/theme-neoretro.vala"
	b1 = MIN (b0 + 0.10, 1.0);
#line 79 "../src/theme-neoretro.vala"
	r2 = MIN (r0 + 0.25, 1.0);
#line 80 "../src/theme-neoretro.vala"
	g2 = MIN (g0 + 0.25, 1.0);
#line 81 "../src/theme-neoretro.vala"
	b2 = MIN (b0 + 0.25, 1.0);
#line 83 "../src/theme-neoretro.vala"
	r5 = MIN (r0 + 0.15, 1.0);
#line 84 "../src/theme-neoretro.vala"
	g5 = MIN (g0 + 0.15, 1.0);
#line 85 "../src/theme-neoretro.vala"
	b5 = MIN (b0 + 0.15, 1.0);
#line 88 "../src/theme-neoretro.vala"
	if (vertical) {
#line 381 "theme-neoretro.c"
		cairo_pattern_t* _tmp0_;
#line 89 "../src/theme-neoretro.vala"
		_tmp0_ = cairo_pattern_create_linear (0.0, 0.0, 1.0, 0.0);
#line 89 "../src/theme-neoretro.vala"
		_cairo_pattern_destroy0 (pattern);
#line 89 "../src/theme-neoretro.vala"
		pattern = _tmp0_;
#line 389 "theme-neoretro.c"
	} else {
		cairo_pattern_t* _tmp1_;
#line 91 "../src/theme-neoretro.vala"
		_tmp1_ = cairo_pattern_create_linear (0.0, 0.0, 0.0, 1.0);
#line 91 "../src/theme-neoretro.vala"
		_cairo_pattern_destroy0 (pattern);
#line 91 "../src/theme-neoretro.vala"
		pattern = _tmp1_;
#line 398 "theme-neoretro.c"
	}
#line 92 "../src/theme-neoretro.vala"
	_tmp2_ = pattern;
#line 92 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp2_, 0.00, r2, g2, b2, 1.0);
#line 93 "../src/theme-neoretro.vala"
	_tmp3_ = pattern;
#line 93 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp3_, 0.08, r1, g1, b1, 1.0);
#line 94 "../src/theme-neoretro.vala"
	_tmp4_ = pattern;
#line 94 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, 0.50, r5, g5, b5, 1.0);
#line 95 "../src/theme-neoretro.vala"
	_tmp5_ = pattern;
#line 95 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp5_, 0.92, r1, g1, b1, 1.0);
#line 96 "../src/theme-neoretro.vala"
	_tmp6_ = pattern;
#line 96 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp6_, 1.00, r0, g0, b0, 1.0);
#line 98 "../src/theme-neoretro.vala"
	result = pattern;
#line 98 "../src/theme-neoretro.vala"
	return result;
#line 424 "theme-neoretro.c"
}

static gdouble
neo_retro_theme_hex_value (gchar c)
{
	gboolean _tmp0_ = FALSE;
	gdouble result;
#line 103 "../src/theme-neoretro.vala"
	if (c >= '0') {
#line 103 "../src/theme-neoretro.vala"
		_tmp0_ = c <= '9';
#line 436 "theme-neoretro.c"
	} else {
#line 103 "../src/theme-neoretro.vala"
		_tmp0_ = FALSE;
#line 440 "theme-neoretro.c"
	}
#line 103 "../src/theme-neoretro.vala"
	if (_tmp0_) {
#line 104 "../src/theme-neoretro.vala"
		result = (gdouble) (c - '0');
#line 104 "../src/theme-neoretro.vala"
		return result;
#line 448 "theme-neoretro.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 105 "../src/theme-neoretro.vala"
		if (c >= 'a') {
#line 105 "../src/theme-neoretro.vala"
			_tmp1_ = c <= 'f';
#line 455 "theme-neoretro.c"
		} else {
#line 105 "../src/theme-neoretro.vala"
			_tmp1_ = FALSE;
#line 459 "theme-neoretro.c"
		}
#line 105 "../src/theme-neoretro.vala"
		if (_tmp1_) {
#line 106 "../src/theme-neoretro.vala"
			result = (gdouble) ((c - 'a') + 10);
#line 106 "../src/theme-neoretro.vala"
			return result;
#line 467 "theme-neoretro.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 107 "../src/theme-neoretro.vala"
			if (c >= 'A') {
#line 107 "../src/theme-neoretro.vala"
				_tmp2_ = c <= 'F';
#line 474 "theme-neoretro.c"
			} else {
#line 107 "../src/theme-neoretro.vala"
				_tmp2_ = FALSE;
#line 478 "theme-neoretro.c"
			}
#line 107 "../src/theme-neoretro.vala"
			if (_tmp2_) {
#line 108 "../src/theme-neoretro.vala"
				result = (gdouble) ((c - 'A') + 10);
#line 108 "../src/theme-neoretro.vala"
				return result;
#line 486 "theme-neoretro.c"
			} else {
#line 110 "../src/theme-neoretro.vala"
				result = 0.0;
#line 110 "../src/theme-neoretro.vala"
				return result;
#line 492 "theme-neoretro.c"
			}
		}
	}
}

static void
neo_retro_theme_real_configure (Theme* base,
                                guint new_size)
{
	NeoRetroTheme * self;
	gboolean _tmp0_ = FALSE;
	gdouble highlight_radius = 0.0;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
#line 155 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 157 "../src/theme-neoretro.vala"
	if (self->priv->size != ((guint) 0)) {
#line 157 "../src/theme-neoretro.vala"
		_tmp0_ = self->priv->size == new_size;
#line 518 "theme-neoretro.c"
	} else {
#line 157 "../src/theme-neoretro.vala"
		_tmp0_ = FALSE;
#line 522 "theme-neoretro.c"
	}
#line 157 "../src/theme-neoretro.vala"
	if (_tmp0_) {
#line 158 "../src/theme-neoretro.vala"
		return;
#line 528 "theme-neoretro.c"
	}
#line 161 "../src/theme-neoretro.vala"
	self->priv->arrow_half_h = new_size * 0.5;
#line 162 "../src/theme-neoretro.vala"
	self->priv->neg_arrow_half_h = -self->priv->arrow_half_h;
#line 163 "../src/theme-neoretro.vala"
	self->priv->arrow_w = (new_size * PUZZLE_VIEW_gap_factor) * 0.5;
#line 164 "../src/theme-neoretro.vala"
	self->priv->arrow_x = ((new_size * PUZZLE_VIEW_gap_factor) - self->priv->arrow_w) * 0.5;
#line 166 "../src/theme-neoretro.vala"
	self->priv->arrow_clip_x = -self->priv->arrow_x;
#line 167 "../src/theme-neoretro.vala"
	self->priv->arrow_clip_y = (gdouble) (-new_size);
#line 168 "../src/theme-neoretro.vala"
	self->priv->arrow_clip_w = (2.0 * self->priv->arrow_x) + self->priv->arrow_w;
#line 169 "../src/theme-neoretro.vala"
	self->priv->arrow_clip_h = 2.0 * new_size;
#line 172 "../src/theme-neoretro.vala"
	cairo_matrix_init_identity (&self->priv->matrix);
#line 173 "../src/theme-neoretro.vala"
	cairo_matrix_scale (&self->priv->matrix, 1.0 / new_size, 1.0 / new_size);
#line 176 "../src/theme-neoretro.vala"
	self->priv->socket_margin = MIN ((guint) (new_size * 0.05), (guint) 2);
#line 177 "../src/theme-neoretro.vala"
	self->priv->socket_size = ((gint) new_size) - (((gint) self->priv->socket_margin) * 2);
#line 179 "../src/theme-neoretro.vala"
	neo_retro_theme_init_socket_pattern (self);
#line 182 "../src/theme-neoretro.vala"
	self->priv->half_tile_size = new_size * 0.5;
#line 183 "../src/theme-neoretro.vala"
	highlight_radius = new_size * 0.45;
#line 184 "../src/theme-neoretro.vala"
	_tmp1_ = cairo_pattern_create_radial (self->priv->half_tile_size, self->priv->half_tile_size, 0.0, self->priv->half_tile_size, self->priv->half_tile_size, highlight_radius);
#line 184 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 184 "../src/theme-neoretro.vala"
	self->priv->highlight_tile_pattern = _tmp1_;
#line 186 "../src/theme-neoretro.vala"
	_tmp2_ = self->priv->highlight_tile_pattern;
#line 186 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp2_, 0.0, 1.0, 1.0, 1.0, 1.0);
#line 187 "../src/theme-neoretro.vala"
	_tmp3_ = self->priv->highlight_tile_pattern;
#line 187 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp3_, 0.2, 1.0, 1.0, 1.0, 0.8);
#line 188 "../src/theme-neoretro.vala"
	_tmp4_ = self->priv->highlight_tile_pattern;
#line 188 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, 0.3, 1.0, 1.0, 1.0, 0.5);
#line 189 "../src/theme-neoretro.vala"
	_tmp5_ = self->priv->highlight_tile_pattern;
#line 189 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp5_, 0.4, 1.0, 1.0, 1.0, 0.2);
#line 190 "../src/theme-neoretro.vala"
	_tmp6_ = self->priv->highlight_tile_pattern;
#line 190 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp6_, 0.5, 1.0, 1.0, 1.0, 0.1);
#line 191 "../src/theme-neoretro.vala"
	_tmp7_ = self->priv->highlight_tile_pattern;
#line 191 "../src/theme-neoretro.vala"
	cairo_pattern_add_color_stop_rgba (_tmp7_, 1.0, 1.0, 1.0, 1.0, 0.0);
#line 194 "../src/theme-neoretro.vala"
	self->priv->tile_margin = MIN ((guint) (new_size * 0.05), (guint) 2) - 1;
#line 195 "../src/theme-neoretro.vala"
	self->priv->tile_size = ((gint) new_size) - (((gint) self->priv->tile_margin) * 2);
#line 198 "../src/theme-neoretro.vala"
	self->priv->font_size = (new_size * 4.0) / 19.0;
#line 199 "../src/theme-neoretro.vala"
	self->priv->north_number_y = (new_size * 4.0) / 18.0;
#line 200 "../src/theme-neoretro.vala"
	self->priv->south_number_y = (new_size * 14.0) / 18.0;
#line 201 "../src/theme-neoretro.vala"
	self->priv->east_number_x = (new_size * 15.0) / 19.0;
#line 202 "../src/theme-neoretro.vala"
	self->priv->west_number_x = (new_size * 4.0) / 19.0;
#line 205 "../src/theme-neoretro.vala"
	self->priv->size = new_size;
#line 606 "theme-neoretro.c"
}

static void
neo_retro_theme_real_set_animation_level (Theme* base,
                                          guint8 new_animation_level)
{
	NeoRetroTheme * self;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
#line 208 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 210 "../src/theme-neoretro.vala"
	self->priv->animation_level = new_animation_level;
#line 211 "../src/theme-neoretro.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 211 "../src/theme-neoretro.vala"
		_tmp0_ = 0.3;
#line 624 "theme-neoretro.c"
	} else {
#line 211 "../src/theme-neoretro.vala"
		_tmp0_ = (0.3 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0;
#line 628 "theme-neoretro.c"
	}
#line 211 "../src/theme-neoretro.vala"
	self->priv->arrow_border_opacity = _tmp0_;
#line 212 "../src/theme-neoretro.vala"
	if (((gint) self->priv->animation_level) == 0) {
#line 212 "../src/theme-neoretro.vala"
		_tmp1_ = 0.1;
#line 636 "theme-neoretro.c"
	} else {
#line 212 "../src/theme-neoretro.vala"
		_tmp1_ = (0.1 * (16.0 - ((gdouble) self->priv->animation_level))) / 16.0;
#line 640 "theme-neoretro.c"
	}
#line 212 "../src/theme-neoretro.vala"
	self->priv->arrow_fill_opacity = _tmp1_;
#line 213 "../src/theme-neoretro.vala"
	neo_retro_theme_init_socket_pattern (self);
#line 646 "theme-neoretro.c"
}

static void
neo_retro_theme_init_socket_pattern (NeoRetroTheme* self)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	cairo_pattern_t* _tmp6_;
	cairo_pattern_t* _tmp7_;
	cairo_pattern_t* _tmp8_;
	cairo_pattern_t* _tmp9_;
	cairo_pattern_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
	cairo_matrix_t _tmp12_;
#line 216 "../src/theme-neoretro.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/theme-neoretro.vala"
	_tmp0_ = cairo_pattern_create_mesh ();
#line 218 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 218 "../src/theme-neoretro.vala"
	self->priv->socket_pattern = _tmp0_;
#line 219 "../src/theme-neoretro.vala"
	_tmp1_ = self->priv->socket_pattern;
#line 219 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_begin_patch (_tmp1_);
#line 220 "../src/theme-neoretro.vala"
	_tmp2_ = self->priv->socket_pattern;
#line 220 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_move_to (_tmp2_, 0.0, 0.0);
#line 221 "../src/theme-neoretro.vala"
	_tmp3_ = self->priv->socket_pattern;
#line 221 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_line_to (_tmp3_, 1.0, 0.0);
#line 222 "../src/theme-neoretro.vala"
	_tmp4_ = self->priv->socket_pattern;
#line 222 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_line_to (_tmp4_, 1.0, 1.0);
#line 223 "../src/theme-neoretro.vala"
	_tmp5_ = self->priv->socket_pattern;
#line 223 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_line_to (_tmp5_, 0.0, 1.0);
#line 224 "../src/theme-neoretro.vala"
	_tmp6_ = self->priv->socket_pattern;
#line 224 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_set_corner_color_rgba (_tmp6_, (guint) 0, 0.3, 0.3, 0.3, self->priv->arrow_border_opacity);
#line 225 "../src/theme-neoretro.vala"
	_tmp7_ = self->priv->socket_pattern;
#line 225 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_set_corner_color_rgba (_tmp7_, (guint) 1, 0.4, 0.4, 0.4, self->priv->arrow_border_opacity);
#line 226 "../src/theme-neoretro.vala"
	_tmp8_ = self->priv->socket_pattern;
#line 226 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_set_corner_color_rgba (_tmp8_, (guint) 2, 0.7, 0.7, 0.7, self->priv->arrow_border_opacity);
#line 227 "../src/theme-neoretro.vala"
	_tmp9_ = self->priv->socket_pattern;
#line 227 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_set_corner_color_rgba (_tmp9_, (guint) 3, 0.6, 0.6, 0.6, self->priv->arrow_border_opacity);
#line 228 "../src/theme-neoretro.vala"
	_tmp10_ = self->priv->socket_pattern;
#line 228 "../src/theme-neoretro.vala"
	cairo_mesh_pattern_end_patch (_tmp10_);
#line 229 "../src/theme-neoretro.vala"
	_tmp11_ = self->priv->socket_pattern;
#line 229 "../src/theme-neoretro.vala"
	_tmp12_ = self->priv->matrix;
#line 229 "../src/theme-neoretro.vala"
	cairo_pattern_set_matrix (_tmp11_, &_tmp12_);
#line 719 "theme-neoretro.c"
}

static void
neo_retro_theme_real_draw_arrow (Theme* base,
                                 cairo_t* context)
{
	NeoRetroTheme * self;
#line 236 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 236 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 238 "../src/theme-neoretro.vala"
	cairo_translate (context, self->priv->arrow_x, 0.0);
#line 251 "../src/theme-neoretro.vala"
	cairo_rectangle (context, self->priv->arrow_clip_x, self->priv->arrow_clip_y, self->priv->arrow_clip_w, self->priv->arrow_clip_h);
#line 253 "../src/theme-neoretro.vala"
	cairo_move_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 254 "../src/theme-neoretro.vala"
	cairo_line_to (context, 0.0, 0.0);
#line 255 "../src/theme-neoretro.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 256 "../src/theme-neoretro.vala"
	cairo_curve_to (context, 0.0, 10.0, 0.0, -10.0, self->priv->arrow_w, self->priv->arrow_half_h);
#line 260 "../src/theme-neoretro.vala"
	cairo_clip (context);
#line 264 "../src/theme-neoretro.vala"
	cairo_move_to (context, self->priv->arrow_w, self->priv->arrow_half_h);
#line 265 "../src/theme-neoretro.vala"
	cairo_line_to (context, 0.0, 0.0);
#line 266 "../src/theme-neoretro.vala"
	cairo_line_to (context, self->priv->arrow_w, self->priv->neg_arrow_half_h);
#line 267 "../src/theme-neoretro.vala"
	cairo_curve_to (context, 0.0, 10.0, 0.0, -10.0, self->priv->arrow_w, self->priv->arrow_half_h);
#line 271 "../src/theme-neoretro.vala"
	cairo_set_line_join (context, CAIRO_LINE_JOIN_ROUND);
#line 272 "../src/theme-neoretro.vala"
	cairo_set_line_cap (context, CAIRO_LINE_CAP_ROUND);
#line 274 "../src/theme-neoretro.vala"
	cairo_set_line_width (context, 14.0);
#line 275 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, self->priv->arrow_border_opacity);
#line 276 "../src/theme-neoretro.vala"
	cairo_stroke_preserve (context);
#line 278 "../src/theme-neoretro.vala"
	cairo_set_line_width (context, 12.0);
#line 279 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, self->priv->arrow_fill_opacity);
#line 280 "../src/theme-neoretro.vala"
	cairo_stroke_preserve (context);
#line 284 "../src/theme-neoretro.vala"
	cairo_reset_clip (context);
#line 285 "../src/theme-neoretro.vala"
	cairo_clip (context);
#line 287 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, self->priv->arrow_border_opacity);
#line 288 "../src/theme-neoretro.vala"
	cairo_fill_preserve (context);
#line 290 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 1.0, 1.0, 1.0, self->priv->arrow_fill_opacity);
#line 291 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 781 "theme-neoretro.c"
}

static void
neo_retro_theme_real_draw_socket (Theme* base,
                                  cairo_t* context)
{
	NeoRetroTheme * self;
	cairo_pattern_t* _tmp0_;
#line 298 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 298 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 300 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 302 "../src/theme-neoretro.vala"
	_tmp0_ = self->priv->socket_pattern;
#line 302 "../src/theme-neoretro.vala"
	cairo_set_source (context, _tmp0_);
#line 304 "../src/theme-neoretro.vala"
	neo_retro_theme_rounded_square (context, (gdouble) self->priv->socket_margin, (gdouble) self->priv->socket_margin, self->priv->socket_size, (gdouble) 8);
#line 308 "../src/theme-neoretro.vala"
	cairo_fill_preserve (context);
#line 310 "../src/theme-neoretro.vala"
	cairo_set_line_width (context, 1.0);
#line 311 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, self->priv->arrow_border_opacity);
#line 312 "../src/theme-neoretro.vala"
	cairo_stroke (context);
#line 314 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 812 "theme-neoretro.c"
}

static void
neo_retro_theme_real_draw_highlight (Theme* base,
                                     cairo_t* context,
                                     gboolean has_tile)
{
	NeoRetroTheme * self;
	cairo_pattern_t* _tmp0_;
#line 321 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 321 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 323 "../src/theme-neoretro.vala"
	_tmp0_ = self->priv->highlight_tile_pattern;
#line 323 "../src/theme-neoretro.vala"
	cairo_set_source (context, _tmp0_);
#line 324 "../src/theme-neoretro.vala"
	cairo_rectangle (context, 0.0, 0.0, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 325 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 834 "theme-neoretro.c"
}

static void
neo_retro_theme_real_draw_paused_tile (Theme* base,
                                       cairo_t* context)
{
	NeoRetroTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
	cairo_pattern_t* _tmp2_;
	cairo_pattern_t* _tmp3_;
#line 332 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 332 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 334 "../src/theme-neoretro.vala"
	_tmp0_ = self->priv->paused_color_h;
#line 334 "../src/theme-neoretro.vala"
	_tmp1_ = self->priv->paused_color_v;
#line 334 "../src/theme-neoretro.vala"
	_tmp2_ = self->priv->paused_color_h;
#line 334 "../src/theme-neoretro.vala"
	_tmp3_ = self->priv->paused_color_v;
#line 334 "../src/theme-neoretro.vala"
	neo_retro_theme_draw_tile_background (self, context, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 860 "theme-neoretro.c"
}

static void
neo_retro_theme_real_draw_tile (Theme* base,
                                cairo_t* context,
                                Tile* tile,
                                gboolean highlight)
{
	NeoRetroTheme * self;
	cairo_pattern_t* _tmp24_;
	cairo_pattern_t* _tmp25_;
	cairo_pattern_t* _tmp26_;
	cairo_pattern_t* _tmp27_;
#line 337 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) base;
#line 337 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 337 "../src/theme-neoretro.vala"
	g_return_if_fail (tile != NULL);
#line 339 "../src/theme-neoretro.vala"
	if (highlight) {
#line 882 "theme-neoretro.c"
		cairo_pattern_t* _tmp0_;
		cairo_matrix_t _tmp1_;
		cairo_pattern_t* _tmp2_;
		cairo_matrix_t _tmp3_;
		cairo_pattern_t* _tmp4_;
		cairo_matrix_t _tmp5_;
		cairo_pattern_t* _tmp6_;
		cairo_matrix_t _tmp7_;
		cairo_pattern_t* _tmp8_;
		cairo_pattern_t* _tmp9_;
		cairo_pattern_t* _tmp10_;
		cairo_pattern_t* _tmp11_;
#line 341 "../src/theme-neoretro.vala"
		_tmp0_ = self->priv->tile_highlights_h[tile->north];
#line 341 "../src/theme-neoretro.vala"
		_tmp1_ = self->priv->matrix;
#line 341 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp0_, &_tmp1_);
#line 342 "../src/theme-neoretro.vala"
		_tmp2_ = self->priv->tile_highlights_h[tile->south];
#line 342 "../src/theme-neoretro.vala"
		_tmp3_ = self->priv->matrix;
#line 342 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp2_, &_tmp3_);
#line 343 "../src/theme-neoretro.vala"
		_tmp4_ = self->priv->tile_highlights_v[tile->east];
#line 343 "../src/theme-neoretro.vala"
		_tmp5_ = self->priv->matrix;
#line 343 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp4_, &_tmp5_);
#line 344 "../src/theme-neoretro.vala"
		_tmp6_ = self->priv->tile_highlights_v[tile->west];
#line 344 "../src/theme-neoretro.vala"
		_tmp7_ = self->priv->matrix;
#line 344 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp6_, &_tmp7_);
#line 346 "../src/theme-neoretro.vala"
		_tmp8_ = self->priv->tile_highlights_h[tile->north];
#line 346 "../src/theme-neoretro.vala"
		_tmp9_ = self->priv->tile_highlights_v[tile->east];
#line 346 "../src/theme-neoretro.vala"
		_tmp10_ = self->priv->tile_highlights_h[tile->south];
#line 346 "../src/theme-neoretro.vala"
		_tmp11_ = self->priv->tile_highlights_v[tile->west];
#line 346 "../src/theme-neoretro.vala"
		neo_retro_theme_draw_tile_background (self, context, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 929 "theme-neoretro.c"
	} else {
		cairo_pattern_t* _tmp12_;
		cairo_matrix_t _tmp13_;
		cairo_pattern_t* _tmp14_;
		cairo_matrix_t _tmp15_;
		cairo_pattern_t* _tmp16_;
		cairo_matrix_t _tmp17_;
		cairo_pattern_t* _tmp18_;
		cairo_matrix_t _tmp19_;
		cairo_pattern_t* _tmp20_;
		cairo_pattern_t* _tmp21_;
		cairo_pattern_t* _tmp22_;
		cairo_pattern_t* _tmp23_;
#line 350 "../src/theme-neoretro.vala"
		_tmp12_ = self->priv->tile_colors_h[tile->north];
#line 350 "../src/theme-neoretro.vala"
		_tmp13_ = self->priv->matrix;
#line 350 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp12_, &_tmp13_);
#line 351 "../src/theme-neoretro.vala"
		_tmp14_ = self->priv->tile_colors_h[tile->south];
#line 351 "../src/theme-neoretro.vala"
		_tmp15_ = self->priv->matrix;
#line 351 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp14_, &_tmp15_);
#line 352 "../src/theme-neoretro.vala"
		_tmp16_ = self->priv->tile_colors_v[tile->east];
#line 352 "../src/theme-neoretro.vala"
		_tmp17_ = self->priv->matrix;
#line 352 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp16_, &_tmp17_);
#line 353 "../src/theme-neoretro.vala"
		_tmp18_ = self->priv->tile_colors_v[tile->west];
#line 353 "../src/theme-neoretro.vala"
		_tmp19_ = self->priv->matrix;
#line 353 "../src/theme-neoretro.vala"
		cairo_pattern_set_matrix (_tmp18_, &_tmp19_);
#line 355 "../src/theme-neoretro.vala"
		_tmp20_ = self->priv->tile_colors_h[tile->north];
#line 355 "../src/theme-neoretro.vala"
		_tmp21_ = self->priv->tile_colors_v[tile->east];
#line 355 "../src/theme-neoretro.vala"
		_tmp22_ = self->priv->tile_colors_h[tile->south];
#line 355 "../src/theme-neoretro.vala"
		_tmp23_ = self->priv->tile_colors_v[tile->west];
#line 355 "../src/theme-neoretro.vala"
		neo_retro_theme_draw_tile_background (self, context, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 977 "theme-neoretro.c"
	}
#line 358 "../src/theme-neoretro.vala"
	cairo_select_font_face (context, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
#line 359 "../src/theme-neoretro.vala"
	cairo_set_font_size (context, self->priv->font_size);
#line 360 "../src/theme-neoretro.vala"
	_tmp24_ = self->priv->text_colors[tile->north];
#line 360 "../src/theme-neoretro.vala"
	neo_retro_theme_draw_number (context, _tmp24_, self->priv->half_tile_size, self->priv->north_number_y, tile->north);
#line 361 "../src/theme-neoretro.vala"
	_tmp25_ = self->priv->text_colors[tile->south];
#line 361 "../src/theme-neoretro.vala"
	neo_retro_theme_draw_number (context, _tmp25_, self->priv->half_tile_size, self->priv->south_number_y, tile->south);
#line 362 "../src/theme-neoretro.vala"
	_tmp26_ = self->priv->text_colors[tile->east];
#line 362 "../src/theme-neoretro.vala"
	neo_retro_theme_draw_number (context, _tmp26_, self->priv->east_number_x, self->priv->half_tile_size, tile->east);
#line 363 "../src/theme-neoretro.vala"
	_tmp27_ = self->priv->text_colors[tile->west];
#line 363 "../src/theme-neoretro.vala"
	neo_retro_theme_draw_number (context, _tmp27_, self->priv->west_number_x, self->priv->half_tile_size, tile->west);
#line 999 "theme-neoretro.c"
}

static void
neo_retro_theme_draw_tile_background (NeoRetroTheme* self,
                                      cairo_t* context,
                                      cairo_pattern_t* north_color,
                                      cairo_pattern_t* east_color,
                                      cairo_pattern_t* south_color,
                                      cairo_pattern_t* west_color)
{
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (self != NULL);
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (north_color != NULL);
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (east_color != NULL);
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (south_color != NULL);
#line 366 "../src/theme-neoretro.vala"
	g_return_if_fail (west_color != NULL);
#line 368 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 371 "../src/theme-neoretro.vala"
	neo_retro_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) 8);
#line 375 "../src/theme-neoretro.vala"
	cairo_clip_preserve (context);
#line 378 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 382 "../src/theme-neoretro.vala"
	cairo_set_source (context, north_color);
#line 383 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 385 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 388 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 390 "../src/theme-neoretro.vala"
	cairo_rectangle (context, 0.0, self->priv->half_tile_size, (gdouble) self->priv->size, self->priv->half_tile_size);
#line 392 "../src/theme-neoretro.vala"
	cairo_set_source (context, south_color);
#line 393 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 395 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 398 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 400 "../src/theme-neoretro.vala"
	cairo_move_to (context, (gdouble) self->priv->size, 0.0);
#line 401 "../src/theme-neoretro.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 402 "../src/theme-neoretro.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 403 "../src/theme-neoretro.vala"
	cairo_close_path (context);
#line 405 "../src/theme-neoretro.vala"
	cairo_set_source (context, east_color);
#line 406 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 408 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 411 "../src/theme-neoretro.vala"
	cairo_save (context);
#line 413 "../src/theme-neoretro.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 414 "../src/theme-neoretro.vala"
	cairo_line_to (context, 0.0, (gdouble) self->priv->size);
#line 415 "../src/theme-neoretro.vala"
	cairo_line_to (context, self->priv->half_tile_size, self->priv->half_tile_size);
#line 416 "../src/theme-neoretro.vala"
	cairo_close_path (context);
#line 418 "../src/theme-neoretro.vala"
	cairo_set_source (context, west_color);
#line 419 "../src/theme-neoretro.vala"
	cairo_fill (context);
#line 421 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 424 "../src/theme-neoretro.vala"
	cairo_reset_clip (context);
#line 425 "../src/theme-neoretro.vala"
	cairo_set_line_width (context, 1.5);
#line 426 "../src/theme-neoretro.vala"
	neo_retro_theme_rounded_square (context, (gdouble) self->priv->tile_margin, (gdouble) self->priv->tile_margin, self->priv->tile_size, (gdouble) 8);
#line 431 "../src/theme-neoretro.vala"
	cairo_set_source_rgba (context, 0.4, 0.4, 0.4, 0.4);
#line 432 "../src/theme-neoretro.vala"
	cairo_stroke_preserve (context);
#line 433 "../src/theme-neoretro.vala"
	cairo_clip (context);
#line 435 "../src/theme-neoretro.vala"
	cairo_move_to (context, 0.0, 0.0);
#line 436 "../src/theme-neoretro.vala"
	cairo_line_to (context, (gdouble) self->priv->size, (gdouble) self->priv->size);
#line 437 "../src/theme-neoretro.vala"
	cairo_move_to (context, 0.0, (gdouble) self->priv->size);
#line 438 "../src/theme-neoretro.vala"
	cairo_line_to (context, (gdouble) self->priv->size, 0.0);
#line 439 "../src/theme-neoretro.vala"
	cairo_stroke (context);
#line 441 "../src/theme-neoretro.vala"
	cairo_restore (context);
#line 1102 "theme-neoretro.c"
}

static void
neo_retro_theme_draw_number (cairo_t* context,
                             cairo_pattern_t* text_color,
                             gdouble x,
                             gdouble y,
                             guint8 number)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	cairo_text_extents_t _tmp3_;
#line 444 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 444 "../src/theme-neoretro.vala"
	g_return_if_fail (text_color != NULL);
#line 446 "../src/theme-neoretro.vala"
	cairo_set_source (context, text_color);
#line 448 "../src/theme-neoretro.vala"
	_tmp0_ = g_strdup_printf ("%hu", (gushort) number);
#line 448 "../src/theme-neoretro.vala"
	text = _tmp0_;
#line 450 "../src/theme-neoretro.vala"
	cairo_text_extents (context, text, &_tmp1_);
#line 450 "../src/theme-neoretro.vala"
	extents = _tmp1_;
#line 451 "../src/theme-neoretro.vala"
	_tmp2_ = extents;
#line 451 "../src/theme-neoretro.vala"
	_tmp3_ = extents;
#line 451 "../src/theme-neoretro.vala"
	cairo_move_to (context, x - (_tmp2_.width / 2.0), y + (_tmp3_.height / 2.0));
#line 452 "../src/theme-neoretro.vala"
	cairo_show_text (context, text);
#line 444 "../src/theme-neoretro.vala"
	_g_free0 (text);
#line 1142 "theme-neoretro.c"
}

static void
neo_retro_theme_rounded_square (cairo_t* context,
                                gdouble x,
                                gdouble y,
                                gint size,
                                gdouble radius_percent)
{
	gdouble radius_arc = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 460 "../src/theme-neoretro.vala"
	g_return_if_fail (context != NULL);
#line 462 "../src/theme-neoretro.vala"
	if (radius_percent <= 0.0) {
#line 463 "../src/theme-neoretro.vala"
		g_assert_not_reached ();
#line 1163 "theme-neoretro.c"
	}
#line 465 "../src/theme-neoretro.vala"
	if (radius_percent > 50.0) {
#line 466 "../src/theme-neoretro.vala"
		radius_percent = 50.0;
#line 1169 "theme-neoretro.c"
	}
#line 467 "../src/theme-neoretro.vala"
	radius_arc = (radius_percent * size) / 100.0;
#line 468 "../src/theme-neoretro.vala"
	x1 = x + radius_arc;
#line 469 "../src/theme-neoretro.vala"
	y1 = y + radius_arc;
#line 470 "../src/theme-neoretro.vala"
	x2 = (x + size) - radius_arc;
#line 471 "../src/theme-neoretro.vala"
	y2 = (y + size) - radius_arc;
#line 473 "../src/theme-neoretro.vala"
	cairo_move_to (context, x, y1);
#line 474 "../src/theme-neoretro.vala"
	cairo_arc (context, x1, y1, radius_arc, G_PI, -NEO_RETRO_THEME_HALF_PI);
#line 475 "../src/theme-neoretro.vala"
	cairo_arc (context, x2, y1, radius_arc, -NEO_RETRO_THEME_HALF_PI, 0.0);
#line 476 "../src/theme-neoretro.vala"
	cairo_arc (context, x2, y2, radius_arc, 0.0, NEO_RETRO_THEME_HALF_PI);
#line 477 "../src/theme-neoretro.vala"
	cairo_arc (context, x1, y2, radius_arc, NEO_RETRO_THEME_HALF_PI, G_PI);
#line 478 "../src/theme-neoretro.vala"
	cairo_close_path (context);
#line 1193 "theme-neoretro.c"
}

NeoRetroTheme*
neo_retro_theme_construct (GType object_type)
{
	NeoRetroTheme * self = NULL;
#line 21 "../src/theme-neoretro.vala"
	self = (NeoRetroTheme*) theme_construct (object_type);
#line 21 "../src/theme-neoretro.vala"
	return self;
#line 1204 "theme-neoretro.c"
}

NeoRetroTheme*
neo_retro_theme_new (void)
{
#line 21 "../src/theme-neoretro.vala"
	return neo_retro_theme_construct (TYPE_NEO_RETRO_THEME);
#line 1212 "theme-neoretro.c"
}

static GObject *
neo_retro_theme_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NeoRetroTheme * self;
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
#line 39 "../src/theme-neoretro.vala"
	parent_class = G_OBJECT_CLASS (neo_retro_theme_parent_class);
#line 39 "../src/theme-neoretro.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 39 "../src/theme-neoretro.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEO_RETRO_THEME, NeoRetroTheme);
#line 41 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 0, "000000", TRUE);
#line 42 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 1, "850023", TRUE);
#line 43 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 2, "e26e1e", FALSE);
#line 44 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 3, "cccc24", FALSE);
#line 45 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 4, "00c656", FALSE);
#line 46 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 5, "005c59", TRUE);
#line 47 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 6, "008de0", FALSE);
#line 48 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 7, "001d87", TRUE);
#line 49 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 8, "a021a6", TRUE);
#line 50 "../src/theme-neoretro.vala"
	neo_retro_theme_make_color_pattern (self, (guint) 9, "e2e2e2", FALSE);
#line 52 "../src/theme-neoretro.vala"
	_tmp0_ = neo_retro_theme_make_dir_color_pattern ("CCCCCC", FALSE, 1.0);
#line 52 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_h);
#line 52 "../src/theme-neoretro.vala"
	self->priv->paused_color_h = _tmp0_;
#line 53 "../src/theme-neoretro.vala"
	_tmp1_ = neo_retro_theme_make_dir_color_pattern ("CCCCCC", TRUE, 1.0);
#line 53 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_v);
#line 53 "../src/theme-neoretro.vala"
	self->priv->paused_color_v = _tmp1_;
#line 39 "../src/theme-neoretro.vala"
	return obj;
#line 1265 "theme-neoretro.c"
}

static void
neo_retro_theme_class_init (NeoRetroThemeClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/theme-neoretro.vala"
	neo_retro_theme_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/theme-neoretro.vala"
	g_type_class_adjust_private_offset (klass, &NeoRetroTheme_private_offset);
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->configure = (void (*) (Theme*, guint)) neo_retro_theme_real_configure;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->set_animation_level = (void (*) (Theme*, guint8)) neo_retro_theme_real_set_animation_level;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->draw_arrow = (void (*) (Theme*, cairo_t*)) neo_retro_theme_real_draw_arrow;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->draw_socket = (void (*) (Theme*, cairo_t*)) neo_retro_theme_real_draw_socket;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->draw_highlight = (void (*) (Theme*, cairo_t*, gboolean)) neo_retro_theme_real_draw_highlight;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->draw_paused_tile = (void (*) (Theme*, cairo_t*)) neo_retro_theme_real_draw_paused_tile;
#line 21 "../src/theme-neoretro.vala"
	((ThemeClass *) klass)->draw_tile = (void (*) (Theme*, cairo_t*, Tile*, gboolean)) neo_retro_theme_real_draw_tile;
#line 21 "../src/theme-neoretro.vala"
	G_OBJECT_CLASS (klass)->constructor = neo_retro_theme_constructor;
#line 21 "../src/theme-neoretro.vala"
	G_OBJECT_CLASS (klass)->finalize = neo_retro_theme_finalize;
#line 1294 "theme-neoretro.c"
}

static void
neo_retro_theme_instance_init (NeoRetroTheme * self,
                               gpointer klass)
{
	cairo_pattern_t* _tmp0_;
	cairo_pattern_t* _tmp1_;
#line 21 "../src/theme-neoretro.vala"
	self->priv = neo_retro_theme_get_instance_private (self);
#line 33 "../src/theme-neoretro.vala"
	_tmp0_ = cairo_pattern_create_rgb (0.0, 0.0, 0.0);
#line 33 "../src/theme-neoretro.vala"
	self->priv->black_text_color = _tmp0_;
#line 34 "../src/theme-neoretro.vala"
	_tmp1_ = cairo_pattern_create_rgb (1.0, 1.0, 1.0);
#line 34 "../src/theme-neoretro.vala"
	self->priv->white_text_color = _tmp1_;
#line 117 "../src/theme-neoretro.vala"
	self->priv->size = (guint) 0;
#line 118 "../src/theme-neoretro.vala"
	self->priv->animation_level = (guint8) 0;
#line 1317 "theme-neoretro.c"
}

static void
neo_retro_theme_finalize (GObject * obj)
{
	NeoRetroTheme * self;
#line 21 "../src/theme-neoretro.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NEO_RETRO_THEME, NeoRetroTheme);
#line 27 "../src/theme-neoretro.vala"
	_vala_array_destroy (self->priv->tile_colors_h, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 28 "../src/theme-neoretro.vala"
	_vala_array_destroy (self->priv->tile_colors_v, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 29 "../src/theme-neoretro.vala"
	_vala_array_destroy (self->priv->tile_highlights_h, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 30 "../src/theme-neoretro.vala"
	_vala_array_destroy (self->priv->tile_highlights_v, 10, (GDestroyNotify) cairo_pattern_destroy);
#line 33 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->black_text_color);
#line 34 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->white_text_color);
#line 36 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_h);
#line 37 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->paused_color_v);
#line 137 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->socket_pattern);
#line 141 "../src/theme-neoretro.vala"
	_cairo_pattern_destroy0 (self->priv->highlight_tile_pattern);
#line 21 "../src/theme-neoretro.vala"
	G_OBJECT_CLASS (neo_retro_theme_parent_class)->finalize (obj);
#line 1348 "theme-neoretro.c"
}

static GType
neo_retro_theme_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NeoRetroThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) neo_retro_theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NeoRetroTheme), 0, (GInstanceInitFunc) neo_retro_theme_instance_init, NULL };
	GType neo_retro_theme_type_id;
	neo_retro_theme_type_id = g_type_register_static (TYPE_THEME, "NeoRetroTheme", &g_define_type_info, 0);
	NeoRetroTheme_private_offset = g_type_add_instance_private (neo_retro_theme_type_id, sizeof (NeoRetroThemePrivate));
	return neo_retro_theme_type_id;
}

GType
neo_retro_theme_get_type (void)
{
	static volatile gsize neo_retro_theme_type_id__once = 0;
	if (g_once_init_enter (&neo_retro_theme_type_id__once)) {
		GType neo_retro_theme_type_id;
		neo_retro_theme_type_id = neo_retro_theme_get_type_once ();
		g_once_init_leave (&neo_retro_theme_type_id__once, neo_retro_theme_type_id);
	}
	return neo_retro_theme_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

